#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <aes.h>
#include <vdi.h>
#include <tos.h>
#include <math.h>
#include <time.h>

char outputs[256];

#include "header.h"
#include "sysdep.h"
#include "euler.h"

#define RESERVE 32*1024l
long reserve=RESERVE;

/* Fuer v_openvwk() */
int work_in[12],
	work_out[57]; /* enthaelt Infos ueber Bildschirm */
	
/* handle ist der fuer VDI-Aufrufe noetige Handle */
int	handle,phys_handle,gl_apid,in_text=1,text_height;

/* Soll Hoehe und Breite von Buchstaben enthalten */
int gl_hchar,gl_wchar,gl_hbox,gl_wbox;

char *graph_screen=0,*text_screen=0;
size_t graph_size;
int graphscr=1,colors,wscreen,hscreen,xscreen,yscreen;
int linelength,wchar,hchar,wchart,hchart,vtext,htext;

OBJECT *menu_tree; /* Enthaelt Resource-Adresse des Menues */
int twi_handle,gwi_handle; /* Handle des Fensters */
int xdesk=0,ydesk=0,wdesk,hdesk; /* Groesse des gesamten 
								Arbeitsbereiches */
int otx,oty,otw,oth,ogx,ogy,ogw,ogh;

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))

#define TEXTSIZE (32*1024l)

char textstart[TEXTSIZE]={0};

int maxlines,cx,cy;
int textheight,textwidth,textoffset;
int cursoron=0,thchar,twchar,editor=0,scrolled=0,ghchar;
char *textend=textstart,*textwindow=textstart,*oldtextwindow;

MFDB mfdb1,mfdb2;

#define telements (NAME|FULLER|SIZER|MOVER|VSLIDE)
#define gelements (NAME|FULLER|SIZER|MOVER)

long msec=0;

char configpath[256];

int pattern [256][16];

/*************** graphics and GEM initialization *************/

void init_pattern (void)
/* Make shading patterns by random */
{	int i,j,k,bits;
	for (i=0; i<256; i++)
		for (j=0; j<16; j++)
		{	bits=0;
			for (k=0; k<16; k++)
				bits=(bits<<1)|((rand()&0x00FF)>i);
			pattern[i][j]=bits;
		}
}

void close_windows (void);
void scan_events (void);
void scroll_up (void);
void scroll_down (void);
void scroll_off (void);
void slide (int pos);

void close_vwork (void)
/***** close_vwork 
	close GEM.
*****/
{	/* exit GEM */
	if (!editor)
	{	wind_update(END_UPDATE);
		graf_mouse(M_ON,0);
	}
	close_windows();
	v_clsvwk(handle);
}

int open_vwork(void)
/***** open_vwork
	open GEM.
*****/
{	int i,attrib[10];
	if ((gl_apid=appl_init()) != -1)
	{	for (i=1; i<10; work_in[i++]=0);
		work_in[10]=2; /* Benutze Pixel-Koordinaten */
		phys_handle=graf_handle(&gl_wchar,&gl_hchar,&gl_wbox,&gl_hbox);
		work_in[0]=handle=phys_handle;
		v_opnvwk(work_in,&handle,work_out);
		vqt_attributes(handle,attrib);
		gl_wchar=attrib[8]; gl_hchar=attrib[9];
		twchar=attrib[6]; thchar=attrib[7]; ghchar=thchar*2/3;
		vst_color(handle,1); vswr_mode(handle,1);
		return 1; /* Erfolg! */
	}
	else return 0;
}

int dialog(int tree, int start)
/* Dies ist ein einfaches Dialogprogramm, das ein Formular aufbaut,
	zentriert, zeichnet, bearbeitet und wieder loescht */
{	OBJECT *tree_addr;
	int x,y,w,h,ret;
	if (rsrc_gaddr(R_TREE,tree,&tree_addr)==0) return 0;
	form_center(tree_addr,&x,&y,&w,&h);
	graf_mouse(M_OFF,0);
	form_dial(FMD_START,0,0,0,0,x,y,w,h);
	form_dial(FMD_GROW,0,0,0,0,x,y,w,h); /* kann entfernt werden */
	objc_draw(tree_addr,0,25,x,y,w,h);
	graf_mouse(M_ON,0);
	ret=form_do(tree_addr,start); /* Hier muss der Benutzer das
			Formular bearbeiten */
	tree_addr[ret].ob_state &= ~SELECTED; /* Exit-Object wieder auf
			nicht selektiert umstellen */
	graf_mouse(M_OFF,0);
	form_dial(FMD_SHRINK,0,0,0,0,x,y,w,h); /* kann entfernt werden */
	form_dial(FMD_FINISH,0,0,0,0,x,y,w,h);
	graf_mouse(M_ON,0);
	return ret; /* Der Knopf mit dem das Formular verlassen wurde */
}

void redraw_all(void)
{	form_dial(FMD_FINISH,0,0,0,0,xdesk,ydesk,wdesk,hdesk);
}

void show_info(void)
/* Ruft die Programminformation auf, in die vorher das Erstellungs-
	datum eingetragen wurde */
{	OBJECT *info;
	if (rsrc_gaddr(R_TREE,FINFO,&info)==0) return;
	dialog(FINFO,0); /* Exit-Button interessiert nicht */
}

void show_size (void)
/* Formular fr Buchstabenhhe */
{	OBJECT *info;
	if (rsrc_gaddr(R_TREE,FSIZE,&info)==0) return;
	sprintf((*(TEDINFO **)(&info[SSIZE].ob_spec))->te_ptext,
		"%d",ghchar);
	if (dialog(FSIZE,0)==SABORT) return;
	sscanf((*(TEDINFO **)(&info[SSIZE].ob_spec))->te_ptext,
		"%d",&ghchar);
	if (ghchar<=0 || ghchar>2*thchar) ghchar=thchar*2/3;
}

int open_windows(void)
/* Oeffnet ein Fenster in maximaler Groesse */
{	FILE *in;
	int tx,ty,tw,th,gx,gy,gw,gh;
	wind_get(0,WF_WORKXYWH,&xdesk,&ydesk,&wdesk,&hdesk);
	if ((in=fopen(configpath,"r"))!=0)
	{	ghchar=0;
		fscanf(in,"%d%d%d%d%d%d%d%d%d",&tx,&ty,&tw,&th,
			&gx,&gy,&gw,&gh,&ghchar);
		if (ghchar<=0 || ghchar>2*thchar) ghchar=thchar*2/3;
		fclose(in);
	}
	else
	{	tx=gx=xdesk; ty=gy=ydesk; tw=gw=wdesk; th=gh=hdesk;
		th-=20; gw-=40;
	}
	otx=ogx=xdesk; oty=ogy=ydesk; otw=ogw=wdesk; oth=ogh=hdesk;
		/* Beschaffe Groesse des Arbeitsbereiches */
	if ((twi_handle=wind_create(telements,
			xdesk,ydesk,wdesk,hdesk))<0)
	{ form_alert(1,"[3][Kein Fenster mehr frei][Abbruch]"); return 1;}
	if ((gwi_handle=wind_create(gelements,
			xdesk,ydesk,wdesk,hdesk))<0)
	{ form_alert(1,"[3][Kein Fenster mehr frei][Abbruch]"); return 1;}
	wind_set(twi_handle,WF_NAME," Dialog ",0,0); /* Infozeile */
	wind_set(gwi_handle,WF_NAME," Graphics ",0,0); /* Infozeile */
	wind_open(gwi_handle,gx,gy,gw,gh); /* Oeffne Fenster */
	wind_open(twi_handle,tx,ty,tw,th); /* Oeffne Fenster */
	scan_events();
	return 0;
}

void close_windows(void)
/* Schliesst Fenster und meldet es ab */
{	wind_close(twi_handle); /* Schliessen */
	wind_close(gwi_handle); /* Schliessen */
	wind_delete(twi_handle); /* Abmelden */
	wind_delete(gwi_handle); /* Abmelden */
}

int rc_intersect(int x, int y, int w, int h,
	int *x1, int *y1, int *w1, int *h1)
/* Unterprogramm, das den Schnitt zweier Rechtecke ausrechnet */
{	int x2,y2;
	x2=max(x,*x1);
	y2=max(y,*y1);
	*w1=min(x+w,*x1+*w1)-x2;
	*h1=min(y+h,*y1+*h1)-y2;
	*x1=x2; *y1=y2;
	return ((*w1>0)&&(*h1>0));
}

void do_textupdate (int p[4]);

void size_text (void)
{	int ww,wh;
	wind_get(twi_handle,WF_WORKXYWH,&htext,&vtext,&ww,&wh);
	htext++; vtext++;
	linelength=(ww-1)/gl_wchar;
	maxlines=(wh-1)/gl_hchar;
	linew=linelength/fieldw;
}

void size_graphics (void)
{	wind_get(gwi_handle,WF_WORKXYWH,&xscreen,&yscreen,&wscreen,&hscreen);
	hchar=(int)(((hchart-1)*1024l)/hscreen);
	wchar=(int)(((wchart-1)*1024l)/wscreen);
}

void redraw(int whandle, int p[4])
/* Neuzeichnung eines Fensters mit Handle whandle in einem Rechteck
	p, gegeben durch linke obere Ecke, rechte untere Ecke */
{	int box[8],i;
	if (whandle==twi_handle) /* Nur wenn es mein Fenster ist! */
	{	size_text();
		do_textupdate(p);
	}
	if (whandle==gwi_handle) /* Nur wenn es mein Fenster ist! */
	{	size_graphics();
		for (i=0; i<4; i++) box[i]=box[4+i]=p[i];
		vro_cpyfm(handle,3,box,&mfdb2,&mfdb1);
	}
}

void do_redraw(int whandle, int x, int y, int w, int h)
/* Uebernimmt allgemein das Neuzeichnen von Fenstern. Ruft daher
redraw auf. Die Fenster werden in Teilrechtecken neu gezeichnet. */
{	int x1,y1,w1,h1,box[4];
	graf_mouse(M_OFF,0);
	wind_update(BEG_UPDATE); /* Sperre Bildschirmzugriff fuer GEM */
	wind_get(whandle,WF_FIRSTXYWH,&x1,&y1,&w1,&h1);
		/* erstes neu zu zeichnendes Rechteck */
	while((w1>0)&&(h1>0))
	{	if (rc_intersect(x,y,w,h,&x1,&y1,&w1,&h1))
		{	box[0]=x1; box[1]=y1; box[2]=w1+x1-1; box[3]=h1+y1-1;
			vs_clip(handle,1,box); /* Clipping gleich hier! */
			redraw(whandle,box); /* Zeichne neu */
		}
		wind_get(whandle,WF_NEXTXYWH,&x1,&y1,&w1,&h1);
			/* Naechstes Rechteck */
	}
	wind_update(END_UPDATE); /* Gib GEM wieder frei! */
	graf_mouse(M_ON,0);
}

void set_gtext (void)
{	int dummy;
	vst_height(handle,ghchar,&dummy,&dummy,&wchart,&hchart);
	hchar=(int)(((hchart-1)*1024l)/hscreen);
	wchar=(int)(((wchart-1)*1024l)/wscreen);
}

void set_text (void)
{	int dummy;
	vst_height(handle,thchar,&dummy,&dummy,&dummy,&dummy);
	vst_alignment(handle,0,5,&dummy,&dummy);
}

int memory_init (void)
/***** memory_init
	get colors, wscreen, hscreen.
	get the graphics screen.
	get all memory (minus reservefor editor) for stack.
*****/
{	long size;
	int nplanes,i;
	/* determine graphic planes */
	nplanes=1; colors=2; 
	while (colors<work_out[13]) { colors*=2; nplanes++; }
	wscreen=work_out[0]+1; hscreen=work_out[1]+1;
	if (graphscr) graph_screen=(char *)Malloc(
		(size=(((long)wscreen*hscreen)/8)*nplanes+1024l));
	if (graph_screen)
		graph_screen=(char *)(((long)graph_screen/1024+1)*1024);
	if (!graph_screen)
	{	form_alert(1,"[1][Not enough memory!][Sorry]"); exit(1);
	}
	text_screen=Physbase();
	graph_size=size-1024l;
	memset(graph_screen,0,size-1024l);
	size=(long)Malloc(-1l);
	if (size<reserve) return 0;
	ramstart=(char *)Malloc(size-reserve);
	if (!ramstart) return 0;
	ramend=ramstart+size;
	mfdb2.fd_nplanes=1; i=2; while (i<work_out[13]) 
		{ i*=2; mfdb2.fd_nplanes++; }
	mfdb2.fd_w=(work_out[0]+1); mfdb2.fd_h=(work_out[1]+1);
	mfdb2.fd_wdwidth=(work_out[0]+1)>>4;
	mfdb2.fd_stand=0; mfdb2.fd_addr=graph_screen;
	mfdb1.fd_addr=0;
	return 1;
}

int shrink (size_t size)
{	if (size<0) return 0;
	else if (size>0)
	{	if (Mshrink(0,ramstart,(ramend-ramstart)-size)<0) return 0;
	}
	return 1;
}

/******************** some graphic support functions ************/

int column (double c)
{	long res;
	res=xscreen+(long)(c*wscreen/1024);
	return (int)res;
}

int row (double c)
{	long res;
	res=yscreen+(long)(c*hscreen/1024);
	return (int)res;
}

void longwrite (double n)
{	long k[1];
	k[0]=(long)(n*1000.0);
	if (metafile) fwrite(k,sizeof(long),1,metafile);
}

void intwrite (int n)
{	int k[1];
	k[0]=n;
	if (metafile) fwrite(k,sizeof(int),1,metafile);
}

void stringwrite (char *s)
{	int c;
	if (metafile)
	{	c=0;
		while (*s) { putc(*s++,metafile); c++; }
		putc(0,metafile); c++;
		if (c%2) putc(0,metafile);
	}
}

void graphic_mode (void)
/***** graphics
	switch to graphics. text should not be deleted.
*****/
{	int p[4];
	if (!in_text) return;
	wind_set(gwi_handle,WF_TOP);
	in_text=0;
	wind_get(gwi_handle,WF_FIRSTXYWH,&xscreen,&yscreen,&wscreen,&hscreen);
	p[0]=xscreen; p[1]=yscreen;
	p[2]=xscreen+wscreen-1; p[3]=yscreen+hscreen-1;
	vs_clip(handle,1,p);
	set_gtext();
	scan_events();
}

void text_mode (void)
/***** text_mode
	switch to text. graphics should not be deleted.
*****/
{	int p[8];
	if (in_text) return;
	p[0]=p[4]=xscreen; p[1]=p[5]=yscreen;
	p[2]=p[6]=xscreen+wscreen-1; p[3]=p[7]=yscreen+hscreen-1;
	vro_cpyfm(handle,3,p,&mfdb1,&mfdb2);
	wind_set(twi_handle,WF_TOP);
	set_text();
	in_text=1;
	scan_events();
}

int oldstyle=-1,oldcol=-1,oldwidth=-1,oldmcol=-1,oldmtype=-1;

void gline (double c, double r, double c1, double r1, int col,
	int st, int width)
/***** gline
	draw a line.
*****/
{	int x[4];
	if (fabs(r)>10000.0) return;
	if (fabs(c)>10000.0) return;
	if (fabs(r1)>10000.0) return;
	if (fabs(c1)>10000.0) return;
	if (metafile)
	{	intwrite(1);
		longwrite(c); longwrite(r); longwrite(c1); longwrite(r1);
		intwrite(col); intwrite(st); intwrite(width);
	}
	if (col>=colors) col=1;
	if (oldstyle!=st)
	{	switch(oldstyle=st)
		{	case line_none : return;
			case line_solid : vsl_type(handle,1); break;
			case line_dotted : vsl_type(handle,3); break;
			case line_dashed : vsl_type(handle,5); break;
		}
	}
	if (oldcol!=col) vsl_color(handle,oldcol=((colors>2)?col:1)); 
	if (oldwidth!=width) vsl_width(handle,oldwidth=width);
	x[0]=column(c); x[1]=row(r);
	x[2]=column(c1); x[3]=row(r1);
	v_pline(handle,2,x);
}

void gmarker (double c, double r, int col, int type)
/***** gmarker
	plot a single marker on screen.
*****/
{	int cc[2];
	if (metafile)
	{	intwrite(2);
		longwrite(c); longwrite(r);
		intwrite(col); intwrite(type);
	}
	cc[0]=column(c); cc[1]=row(r);
	if (oldmtype!=type)
	{	switch (oldmtype=type)
		{	case marker_dot : vsm_type(handle,1); break;
			case marker_plus : vsm_type(handle,2); break;
			case marker_star : vsm_type(handle,3); break;
			case marker_square : vsm_type(handle,4); break;
			case marker_cross : vsm_type(handle,5); break;
			case marker_diamond : vsm_type(handle,6); break;
		}
	}
	if (oldmcol!=col) vsm_color(handle,oldmcol=col);
	v_pmarker(handle,1,cc);
}

void gfill (double c[], int st, int n, int connect[])
/***** gfill
	fill an area given by n pairs of points (in c: x,y,x,y,...)
	with the style. connect the pairs indicated in connect.
*****/
{	int i,cc[64],ci[64],j,count;
	if (n>32) return;
	for (i=0; i<2*n; i++) if (fabs(c[i])>10000.0) return;
	if (metafile)
	{	intwrite(3);
		for (i=0; i<2*n; i+=2)
		{	longwrite(c[i]); longwrite(c[i+1]);
			intwrite(connect[i]);
		}
		intwrite(st);
	}
	if (st==fill_filled) 
	{	vsf_interior(handle,2);
		vsf_style(handle,3);
		vsf_perimeter(handle,0);
		if (colors>2) vsf_color(handle,3);
		else vsf_color(handle,1);
	}
	else
	{	if (colors>2)
		{	vsf_interior(handle,1);
			vsf_perimeter(handle,1);
			vsf_color(handle,3);
		}
		else
		{	vsf_interior(handle,2);
			vsf_style(handle,2);
			vsf_perimeter(handle,0);
			vsf_color(handle,1);
		}
	}
	for (i=0; i<2*n; i+=2) ci[i]=(int)column(c[i]);
	for (i=1; i<2*n; i+=2) ci[i]=(int)row(c[i]);
	v_fillarea(handle,n,ci);
	if (oldcol!=1) vsl_color(handle,oldcol=1);
	if (oldstyle!=line_solid) { vsl_type(handle,1); oldstyle=line_solid; }
	if (oldwidth!=1) vsl_width(handle,oldwidth=1);
	i=0;
	while (i<n)
	{	j=0; count=0;
		while (i<n && connect[i])
		{	cc[j++]=ci[2*i]; cc[j++]=ci[2*i+1];
			i++; count++;
		}
		if (i==n)
		{	cc[j++]=ci[0]; cc[j++]=ci[1]; count++;
		}
		else
		{	cc[j++]=ci[2*i]; cc[j++]=ci[2*i+1]; count++;
		}
		v_pline(handle,count,cc);
		while (i<n && !connect[i]) i++;
	}
}

void sethue (double hue, int color)
{	int col;
	hue-=floor(hue);
	hue*=0.99999;
	if (work_out[13]>4 && color==0)
	{	vsf_interior(handle,1); 
		col=3+floor(hue*(work_out[13]-2));
		if (col<4) col=1;
		if (col>=work_out[13]) col=0;
	}
	else if (work_out[13]>2 && color<0)
	{	hue*=(work_out[13]-1);
		vsf_interior(handle,4);
		vsf_udpat(handle,pattern[floor((hue-floor(hue))*256)],1);
		vsf_color(handle,1+floor(hue));
		vsf_perimeter(handle,0);
	}
	else
	{	vsf_interior(handle,4);
		vsf_udpat(handle,pattern[floor(hue*256)],1);
		vsf_color(handle,color>=1?color:1);
		vsf_perimeter(handle,0);
	}
}

void gbar (double c, double r, double c1, double r1, double hue,
	int color, int connect)
{	int p[10];
	if (metafile)
	{	intwrite(7);
		longwrite(c); longwrite(r);
		longwrite(c1); longwrite(r1);
		longwrite((hue-floor(hue))*1000.0); intwrite(color);
	}
	p[0]=column(c); p[2]=column(c1);
	p[1]=row(r); p[3]=row(r1);
	sethue(hue,color);
	v_bar(handle,p);
	if (connect)
	{	p[4]=p[2]; p[5]=p[3];
		p[2]=p[4]; p[3]=p[1];
		p[6]=p[0]; p[7]=p[5];
		p[8]=p[0]; p[9]=p[1];
		if (oldcol!=1) vsl_color(handle,oldcol=1);
		if (oldstyle!=line_solid) { vsl_type(handle,1); oldstyle=line_solid; }
		if (oldwidth!=1) vsl_width(handle,oldwidth=1);
		v_pline(handle,5,p);
	}
}

void gfillh (double c[8], double hue, int color, int connect)
{	int i,ci[10];
	for (i=0; i<8; i++) if (fabs(c[i])>10000.0) return;
	if (metafile)
	{	intwrite(8);
		for (i=0; i<8; i+=2)
		{	longwrite(c[i]); longwrite(c[i+1]);
		}
		longwrite((hue-floor(hue))*1000.0);
		intwrite(color); intwrite(connect);
	}
	sethue(hue,color);
	for (i=0; i<8; i+=2) ci[i]=(int)column(c[i]);
	for (i=1; i<8; i+=2) ci[i]=(int)row(c[i]);
	ci[8]=ci[0]; ci[9]=ci[1];
	v_fillarea(handle,4,ci);
	if (connect)
	{	if (oldcol!=1) vsl_color(handle,oldcol=1);
		if (oldstyle!=line_solid) { vsl_type(handle,1); oldstyle=line_solid; }
		if (oldwidth!=1) vsl_width(handle,oldwidth=1);
		v_pline(handle,5,ci);
	}
}

void gtext (double c, double r, char *text, int color, int alignment)
/***** gtext
	output a graphic text on screen.
*****/
{	int d1,d2;
	set_gtext();
	if (metafile)
	{	intwrite(4); longwrite(c);
		longwrite(r); intwrite(color); intwrite(alignment);
		stringwrite(text);
	}
	vst_color(handle,(colors>2)?color:1);
	vst_alignment(handle,alignment,2,&d1,&d2);
	vswr_mode(handle,2);
	v_gtext(handle,column(c),row(r),text);
	vswr_mode(handle,1);
	vst_color(handle,1);
}

void scale (double s)
/***** scale
	scale the screen according s = true width / true height.
*****/
{	if (metafile)
	{	intwrite(5);
		longwrite((int)(s*1000));
	}
}

void mouse (int *x, int *y)
/****** mouse
	wait, until the user marked a screen point with the mouse.
******/
{	int c,r,b=0;
	graphic_mode();
	graf_mouse(M_ON,0); graf_mouse(THIN_CROSS,0);
	while (!b) vq_mouse(handle,&b,&c,&r);
	while (b) vq_mouse(handle,&b,&c,&r);
	*x=(int)(((long)(c-xscreen)*1024l)/wscreen);
	*y=(int)(((long)(r-yscreen)*1024l)/hscreen);
	graf_mouse(ARROW,0); graf_mouse(M_OFF,0);
}

/*************** configuration ***************/

void save_config (void)
{	FILE *out;
	int xt,yt,wt,ht,xg,yg,wg,hg;
	out=fopen(configpath,"w");
	if (!out)
	{	form_alert(1,"[1][Write error!][Ok]");
		return;
	}
	wind_get(twi_handle,WF_CURRXYWH,&xt,&yt,&wt,&ht);
	wind_get(gwi_handle,WF_CURRXYWH,&xg,&yg,&wg,&hg);
	fprintf(out,"%d %d %d %d\n%d %d %d %d\n%d\n",
		xt,yt,wt,ht,xg,yg,wg,hg,ghchar);
	fclose(out);
}

/******************** keyboard **********************/

char notechar[256];
char path[256]="",path1[256];
char name[32];
int noted=0,notei;

void note (char *string)
{	strcpy(notechar,string);
	noted=1; notei=0;
}

void note_file (char *string)
{	char *p;
	int ret;
	if (!path[0])
	{	path[0]=Dgetdrv()+'A'; path[1]=':';
		Dgetpath(path+2,0);
		strcat(path,"\\*.*");
	}
	strcpy(path1,path);
	fsel_input(path1,name,&ret);
	scan_events();
	if (ret==0) return;
	strcpy(path,path1);
	p=path1+strlen(path1);
	while (p>path1)
	{	if (*p=='\\') { p++; break; } 
		if (*p==':') break;
		p--;
	}
	*p=0;
	sprintf(notechar,string,path1,name);
	noted=1; notei=0;
}

void save_text (void)
{	FILE *out;
	char s[256],*p;
	note_file("%s%s"); noted=0;
	sprintf(s,"[2][File|%s%s|will be deleted!][Ok|Abort]",
		strlen(notechar)>16?"...":"",
		notechar+max(0,(int)strlen(notechar)-16));
	if (form_alert(1,s)==2) return;
	out=fopen(notechar,"w");
	if (out)
	{	p=textstart;
		while (p<textend)
		{	fprintf(out,"%s\n",p);
			p+=strlen(p)+1;
		}
		fprintf(out,"%s\n",p);
		fclose(out);
	}
	else
	form_alert(1,"[1][Could not open that file!][Ok]");
}

void save_graphics (void)
{	FILE *out;
	char s[256];
	note_file("%s%s"); noted=0;
	sprintf(s,"[2][File|%s%s|will be deleted!][Ok|Abort]",
		strlen(notechar)>16?"...":"",
		notechar+max(0,(int)strlen(notechar)-16));
	if (form_alert(1,s)==2) return;
	out=fopen(notechar,"w");
	if (out)
	{	fwrite(graph_screen,graph_size,1,out);
		fclose(out);
	}
	else
	form_alert(1,"[1][Could not open that file!][Ok]");
}

int wait_key (int *scan)
/***** 
	wait for a keystroke. return the scancode and the ascii code.
*****/
{	int msgbuf[12];
	int mx,my,mb,state,key,clicks,evt,taste,x,y,w,h,wh,p[8];
	if (!msec && noted)
	{	if (notechar[notei])
		{	*scan=0; return notechar[notei++];
		}
		noted=0; *scan=enter; return 13;
	}
	do
	{	evt=evnt_multi(
			msec?MU_KEYBD|MU_MESAG|MU_TIMER:MU_KEYBD|MU_MESAG, 
							/* welche Ereignisse? */
			1,3,1, /* 1 Mausklick, beide Maustasten gedrueckt */
			0,600,20,39,20,	/* erstes zu ueberwachendes Rechteck */
			1,600,20,39,20, /* zweites " */
			msgbuf,
			(int)(msec&0x0000FFFF),
			(int)(msec>>16),
			&mx,&my,&mb,&state,&key,&clicks);
		if (evt & MU_MESAG) /* Message eingetroffen? */
		{	switch(msgbuf[0])
			{ case MN_SELECTED : /* Menue angewaehlt */
				{	switch(msgbuf[4])
					{ case MQUIT : close_vwork(); exit(0); 
					  case MINFO : show_info(); break;
					  case MSIZE : show_size(); break;
					}
					menu_tnormal(menu_tree,msgbuf[3],1);
					if (!noted && !msec && editor)
					{	switch (msgbuf[4])
						{	case MCLS : note("cls"); break;
							case MCLG : note("clg"); break;
							case MLONG : note("longformat"); break;
							case MSHORT : note("shortformat"); break;
							case MLIST : note("list"); break;
							case MRESET : note("reset"); break;
							case MLHELP : note("load \"help\""); break;
							case MLDEMO : note("load \"demo\""); break;
							case MSHRINK : note("shrinkwindow"); break;
							case MFULL : note("fullwindow"); break;
							case MDUMPOFF : note("dump"); break;
							case MEXEDIT : note("exec edit"); break;
							case MLFILE : note("load file"); break;
							case MLOAD :
								note_file("load \"%s%s\";"); break;
							case MDUMP :
								note_file("dump \"%s%s\""); break;
							case MCD :
								note_file("cd(\"%s\")"); break;
							case MFILE :
								note_file("file=\"%s%s\";"); break;
							case MCONFIG : save_config(); break;
							case MSTEXT : save_text(); break;
							case MSGRAPH : save_graphics(); break;
							case MDIR : note_file("dir(\"%s*.*\");");
								break;
							default : goto notnote;
						}
						*scan=escape; return 0;
						notnote : ;
					}
				}
				case WM_REDRAW : do_redraw(msgbuf[3],msgbuf[4],
			  		msgbuf[5],msgbuf[6],msgbuf[7]); break;
			  		/* Fenster neu zu zeichnen */
				case WM_TOPPED :
					wind_get(0,WF_TOP,&wh);
					graf_mouse(M_OFF,0);
					if (wh==gwi_handle)
					{	p[0]=p[4]=xscreen; p[1]=p[5]=yscreen;
						p[2]=p[6]=xscreen+wscreen-1;
						p[3]=p[7]=yscreen+hscreen-1;
						vro_cpyfm(handle,3,p,&mfdb1,&mfdb2);
					}
					graf_mouse(M_ON,0);
					wind_set(msgbuf[3],WF_TOP); break;
				case WM_ARROWED :
					if (msgbuf[3]!=twi_handle) break;
					switch(msgbuf[4])
					{	case 0 : scroll_up(); break;
						case 1 : scroll_down(); break;
					}
					break;
				case WM_VSLID :
					if (msgbuf[3]!=twi_handle) break;
					slide(msgbuf[4]); break;
				case WM_SIZED :
				case WM_MOVED :
					wind_set(msgbuf[3],WF_CURRXYWH,
						msgbuf[4],msgbuf[5],msgbuf[6],msgbuf[7]);
					if (msgbuf[3]==twi_handle) size_text();
					else if (msgbuf[3]==gwi_handle) size_graphics();
					break;
				case WM_FULLED :
					if (msgbuf[3]==twi_handle)
					{	wind_get(twi_handle,WF_CURRXYWH,&x,&y,&w,&h);
						wind_set(twi_handle,WF_CURRXYWH,otx,oty,otw,oth);
						otx=x; oty=y; oth=h; otw=w;
					}
					else if (msgbuf[3]==gwi_handle)
					{	wind_get(gwi_handle,WF_CURRXYWH,&x,&y,&w,&h);
						wind_set(gwi_handle,WF_CURRXYWH,ogx,ogy,ogw,ogh);
						ogx=x; ogy=y; ogh=h; ogw=w;
					}
					break;
			}
		}
		else if (evt & MU_KEYBD) /* Taste gedrueckt */
		{	taste=key&0x00FF;
			switch (key>>8)
			{	case 75 : *scan=((taste&0xFF)==0)?cursor_left:line_start; 
					taste=0; break;
				case 77 : *scan=((taste&0xFF)==0)?cursor_right:line_end; 
					taste=0; break;
				case 14 : *scan=backspace; taste=0; break;
				case 83 : *scan=delete; taste=0; break;
				case 72 : 
					if (taste&0xFF) { scroll_up(); continue; }
					else *scan=cursor_up;
					taste=0; break;
				case 80 :
					if (taste&0xFF) { scroll_down(); continue; }
					else *scan=cursor_down;
					taste=0; break;
				case 71 : *scan=clear_home; taste=0; break;
				case 98 : *scan=help; taste=0; break;
				case 28 : *scan=enter; taste=13; break;
				case 57 : *scan=space; taste=32; break;
				case 115 : *scan=word_left; taste=0; break;
				case 116 : *scan=word_right; taste=0; break;
				case 59 : *scan=fk1; taste=0; break;
				case 60 : *scan=fk2; taste=0; break;
				case 61 : *scan=fk3; taste=0; break;
				case 62 : *scan=fk4; taste=0; break;
				case 63 : *scan=fk5; taste=0; break;
				case 64 : *scan=fk6; taste=0; break;
				case 65 : *scan=fk7; taste=0; break;
				case 66 : *scan=fk8; taste=0; break;
				case 67 : *scan=fk9; taste=0; break;
				case 68 : *scan=fk10; taste=0; break;
				case 1 : *scan=escape; taste=0; break;
				case 15 : *scan=switch_screen; taste=0; break;
				default : *scan=-1;
			}
			break;
		}
		else if (evt & MU_TIMER)
		{	*scan=0; break;
		}
	} while (1);
	return taste;
}

int test_key (void)
/***** test_key
	see, if user pressed the keyboard.
	return the scan_code, if he did.
*****/
{	long scan;
	int dummy;
	if (Bconstat(2))
	{	scan=Bconin(2); 
		switch ((int)(scan>>16))
		{	case 1 : return escape;
			case 97 :
				sys_wait(3600.0,&dummy); return 0;
			default : return 'a';
		}
	}
	else return 0;
}

/**************** directory *******************/

char dirpath[256];

char *cd (char *dir)
/* sets the path if dir!=0 and returns the path */
{	if (dir && dir[0])
	{	if (dir[1]==':') Dsetdrv(toupper(dir[0])-'A');
		Dsetpath(dir);
	}
	dirpath[0]=Dgetdrv()+'A'; dirpath[1]=':'; dirpath[2]=0;
	Dgetpath(dirpath+2,0);
	return dirpath;
}

char *dir (char *pattern)
{	DTA *dta;
	static int another=0;
	int error;
	if (pattern)
	{	error=Fsfirst(pattern,0);
		if (error<0) return 0;
		dta=Fgetdta(); another=1;
		return dta->d_fname;
	}
	else
	{	if (!another) return 0;
		error=Fsnext();
		if (error<0) { another=0; return 0; }
		dta=Fgetdta(); another=1;
		return dta->d_fname;
	}
}

/***************** clear screens ********************/

void clear_graphics (void)
/* clear the graphics screen */
{	int p[4];
	if (metafile) intwrite(6);
	p[0]=xscreen; p[1]=yscreen;
	p[2]=xscreen+wscreen-1; p[3]=yscreen+hscreen-1;
	vsf_interior(handle,1); vsf_color(handle,0); v_bar(handle,p);
}

double myclock (void)
/* define a timer in seconds. */
{	return (double)clock()/CLK_TCK;
}

void sys_wait (double time, int *scan)
{	double now;
	int p[8],box[4],h;
	now=myclock();
	if (!in_text)
	{	p[0]=p[4]=xscreen; p[1]=p[5]=yscreen;
		p[2]=p[6]=xscreen+wscreen-1; p[3]=p[7]=yscreen+hscreen-1;
		vro_cpyfm(handle,3,p,&mfdb1,&mfdb2);
	}
	wind_update(END_UPDATE);
	graf_mouse(M_ON,0);
	editor=1;
	while(1)
	{	msec=(long)(((now+time)-myclock())*1000);
		if (msec<=0)
		{	msec=0;
			*scan=0; break;
		}
		wait_key(scan);
		if (*scan) break;
	}
	msec=0;
	editor=0;
	if (!in_text)
	{	wind_get(0,WF_TOP,&h);
		if (h!=gwi_handle)
		{	wind_set(gwi_handle,WF_TOP);
			scan_events();
		}
		wind_get(gwi_handle,WF_WORKXYWH,&xscreen,&yscreen,
			&wscreen,&hscreen);
		box[0]=xscreen; box[1]=yscreen;
		box[2]=xscreen+wscreen-1; box[3]=yscreen+hscreen-1;
		vs_clip(handle,1,box);
	}
	graf_mouse(M_OFF,0);
	wind_update(BEG_UPDATE);
}

void getpixel (double *x, double *y)
/* compute the size of pixel in screen coordinates */
{	*x=1024.0/wscreen;
	*y=1024.0/hscreen;
}

void gflush (void)
{
}

/************** text screen **************************/

void set_slide (void)
{	wind_set(twi_handle,WF_VSLIDE,
		(int)(((textwindow-textstart)*1000l)/(TEXTSIZE-256)));
}

void textdraw (void df (int p[4]))
{	int x1,y1,w1,h1,box[4];
	if (editor)
	{	graf_mouse(M_OFF,0);
		wind_update(BEG_UPDATE);
	}
	wind_get(twi_handle,WF_FIRSTXYWH,&x1,&y1,&w1,&h1);
		/* erstes neu zu zeichnendes Rechteck */
	while((w1>0)&&(h1>0))
	{	box[0]=x1; box[1]=y1; box[2]=w1+x1-1; box[3]=h1+y1-1;
		vs_clip(handle,1,box); /* Clipping gleich hier! */
		df(box); /* Zeichne neu */
		wind_get(twi_handle,WF_NEXTXYWH,&x1,&y1,&w1,&h1);
			/* Naechstes Rechteck */
	}
	if (editor)
	{	wind_update(END_UPDATE);
		graf_mouse(M_ON,0);
	}
}

void do_show_cursor (int p[4])
{	int x,y,q[8];
	char cstring[]=" ";
	x=htext+cx*gl_wchar;
	y=vtext+cy*gl_hchar;
	if (x+gl_wchar<p[0] || x>p[2] || y>p[3] || y+gl_hchar<p[1]) 
		return;
	if (cx>linelength) return;
	cstring[0]=textend[cx];
	if (cstring[0]==0) cstring[0]=' ';
	v_gtext(handle,x,y,cstring);
	q[4]=q[0]=x; q[5]=q[1]=y;
	q[6]=q[2]=q[0]+gl_wchar-1; q[7]=q[3]=q[1]+gl_hchar-1;
	vro_cpyfm(handle,12,q,&mfdb1,&mfdb1);
}

void show_cursor (void)
{	textdraw(do_show_cursor);
}

void do_hide_cursor (int p[4])
{	int x,y;
	char cstring[]=" ";
	x=htext+cx*gl_wchar;
	y=vtext+cy*gl_hchar;
	if (x+gl_wchar<p[0] || x>p[2] || y>p[3] || y+gl_hchar<p[1]) return;
	if (cx>linelength) return;
	cstring[0]=textend[cx];
	if (cstring[0]==0) cstring[0]=' ';
	v_gtext(handle,x,y,cstring);
}

void hide_cursor (void)
{	textdraw(do_hide_cursor);
}

int oldcx;

void do_move_cl (int p[4])
{	cx=oldcx; do_hide_cursor(p); 
	cx=oldcx-1; do_show_cursor(p);
}

void move_cl (void)
{	if (cx<=0) return;
	if (!cursoron) cx--;
	else { oldcx=cx; textdraw(do_move_cl); cx=oldcx-1; }
}

void do_move_cr (int p[4])
{	cx=oldcx; do_hide_cursor(p);
	cx=oldcx+1; do_show_cursor(p);
}

void move_cr (void)
{	if (!cursoron) cx++;
	else { oldcx=cx; textdraw(do_move_cr); cx=oldcx+1; }
}

void cursor_on (void)
{	if (!cursoron) { cursoron=1; show_cursor(); }
}

void cursor_off (void)
{	if (cursoron) { hide_cursor(); cursoron=0; }
}

int tlx,tly;
char *tlp;

void do_textline (int p[4])
{	int yp;
	yp=vtext+tly*gl_hchar;
	if (yp+gl_hchar<p[1] || yp>p[3]) return;
	v_gtext(handle,htext+tlx*gl_wchar,yp,tlp+tlx);
	if (tly==cy && cursoron) do_show_cursor(p);
}

void textline (char *p, int x, int y)
{	tlx=x; tly=y; tlp=p;
	textdraw(do_textline);
}

void do_clearline (int p[4])
{	int box[4],con=cursoron;
	if (con) hide_cursor();
	box[0]=htext+tlx*gl_wchar;
	box[1]=vtext+tly*gl_hchar;
	box[2]=box[0]+(linelength+1)*gl_wchar;
	box[3]=box[1]+gl_hchar;
	if (box[0]>p[2] || box[2]<p[0] || box[1]>p[3] || box[3]<p[1])
		return;
	vsf_interior(handle,0); vsf_color(handle,0); v_bar(handle,box);
	memset(tlp+tlx,0,textstart+TEXTSIZE-(tlp+tlx));
	if (con) show_cursor();
}

void clearline (char *p, int x, int y)
{	tlx=x; tly=y; tlp=p;
	textdraw(do_clearline);
}

void clear_eol (void)
{	clearline(textend,cx,cy);
}

void do_clear_screen (int p[4])
{	vsf_interior(handle,1); vsf_color(handle,0); v_bar(handle,p);
	scrolled=0;
}

void clear_screen (void)
{	cx=0; cy=0;
	textwindow=textend=textstart;
	memset(textstart,0,TEXTSIZE);
	textdraw(do_clear_screen);
	set_slide();
}

void do_textupdate (int p[4])
{	char *tp;
	int i;
	set_text();
	vsf_interior(handle,1); vsf_color(handle,0); v_bar(handle,p);
	tp=textwindow; i=0;
	while (tp<=textend && i<maxlines)
	{	tlp=tp; tlx=0; tly=i; do_textline(p);
		i++; tp+=strlen(tp)+1;
	}
}

void textupdate (void)
{	textdraw(do_textupdate);
}

void new_line (void)
{	int x,y,w,h,x1,y1,w1,h1,p[8],b[4],con=cursoron;
	size_t length;
	char *tp;
	if (con) hide_cursor();
	cy++; cx=0;
	textend+=strlen(textend)+1;
	if (textend>textstart+TEXTSIZE-256)
	{	tp=textstart+(TEXTSIZE-256)/8;
		tp+=strlen(tp)+1;
		memmove(textstart,tp,textend-tp);
		length=tp-textstart;
		textend-=length; textwindow-=length;
	}
	if (cy>=maxlines)
	{
		cy--; textwindow+=strlen(textwindow)+1;
		wind_get(twi_handle,WF_WORKXYWH,&x,&y,&w,&h);
		wind_get(twi_handle,WF_FIRSTXYWH,&x1,&y1,&w1,&h1);
		if (w==w1 && h==h1)
		{	if (editor)
			{	wind_update(BEG_UPDATE);
				graf_mouse(M_OFF,0);
			}
			p[0]=x; p[1]=vtext+gl_hchar;
			p[2]=x+w-1;
			p[3]=p[1]+(maxlines-1)*gl_hchar;
			p[4]=p[0]; p[5]=p[1]-gl_hchar;
			p[6]=p[2]; p[7]=p[3]-gl_hchar;
			vro_cpyfm(handle,3,p,&mfdb1,&mfdb1);
			b[0]=htext;
			b[1]=vtext+(maxlines-1)*gl_hchar;
			b[2]=b[0]+linelength*gl_wchar;
			b[3]=b[1]+gl_hchar;
			tlp=textend; tlx=0; tly=cy; do_clearline(b);
			if (editor)
			{	wind_update(END_UPDATE);
				graf_mouse(M_ON,0);
			}
		}
		else
		{	textupdate();
			clearline(textend,0,cy);
		}
		set_slide();
	}
	if (con) show_cursor();
}

void gprint (char *s)
/* print a line onto the screen, parse tabs and \nl */
{
	int cx0=cx,cx1,i;
	scroll_off();
	while (*s)
	{
		switch(*s)
		{
			case 10 : s++; textline(textend,cx0,cy); cx0=0;
				new_line(); break;
			case 13 : break;
			case 9 :
				cx1=(cx/4+1)*4;
				for (i=cx; i<cx1; i++) textend[i]=' ';
				cx=cx1; s++;
				break;
			default :
				textend[cx]=*s; cx++;
				s++;
				break;
		}
		if (textend+cx>textstart+TEXTSIZE)
		{	cx0=0; new_line(); }
	}
	textline(textend,cx0,cy);
}

void scroll_up (void)
{	int i;
	if (textwindow==textstart) return;
	if (!scrolled) oldtextwindow=textwindow;
	for (i=0; i<maxlines-1; i++)
	{	if (textwindow==textstart) break;
		textwindow--;
		while (textwindow>textstart && *(textwindow-1)!=0)
			textwindow--;
	}
	scrolled=1; cursoron=0;
	textupdate();
	set_slide();
}

void slide (int pos)
{	char *tp;
	if (!scrolled && textwindow==textstart) return;
	if (!scrolled) oldtextwindow=textwindow;
	tp=textstart+pos*(TEXTSIZE-256)/1000l;
	if (pos>0) tp=tp+strlen(tp)+1;
	if (tp>=oldtextwindow)
	{	cursoron=1; scrolled=0; textwindow=oldtextwindow; }
	else
	{	textwindow=tp; scrolled=1; cursoron=0; }
	textupdate();
	set_slide();
}

void scroll_down (void)
{	int i;
	if (!scrolled) return;
	for (i=0; i<maxlines-1; i++)
	{	if (textwindow>=oldtextwindow) break;
		textwindow+=strlen(textwindow)+1;
	}
	if (textwindow>=oldtextwindow)
	{	scrolled=0; cursoron=1; textwindow=oldtextwindow;
	}
	textupdate();
	set_slide();
}

void scroll_off (void)
{	if (!scrolled) return;
	textwindow=oldtextwindow;
	scrolled=0; cursoron=1;
	textupdate();
	set_slide();
}	

/************* event scanning ****************************/

void scan_events (void)
{	int msgbuf[8];
	int mx,my,mb,state,key,clicks,evt;
	do
	{	evt=evnt_multi(MU_MESAG|MU_TIMER, 
							/* welche Ereignisse? */
			1,3,1, /* 1 Mausklick, beide Maustasten gedrueckt */
			0,600,20,39,20,	/* erstes zu ueberwachendes Rechteck */
			1,600,20,39,20, /* zweites " */
			msgbuf,
			0,0,	/* Timer auf 0 Sekunden einstellen */
			&mx,&my,&mb,&state,&key,&clicks);
		if (evt & MU_MESAG) /* Message eingetroffen? */
		{	switch(msgbuf[0])
			{ case MN_SELECTED : /* Menue angewaehlt */
				{	switch(msgbuf[4])
					{ case MQUIT : 
						close_vwork(); exit(0); break; 
					  case MINFO : show_info(); break;
					  case MSIZE : show_size(); break;
					}
					menu_tnormal(menu_tree,msgbuf[3],1);
				}
			  case WM_REDRAW : do_redraw(msgbuf[3],msgbuf[4],
			  		msgbuf[5],msgbuf[6],msgbuf[7]); break;
			}
		}
		else if (evt & MU_TIMER) break;
	} while (1);
}

void edit_off (void)
{	graf_mouse(M_OFF,0);
	cursor_off();
	wind_update(BEG_UPDATE);
	editor=0;
}

void edit_on (void)
{	int h;
	wind_update(END_UPDATE);
	editor=1;
	graf_mouse(M_ON,0);
	wind_get(0,WF_TOP,&h);
	if (h!=twi_handle) wind_set(twi_handle,WF_TOP);
	cursor_on();
}

/********** execute programs *************************/


int execute (char *name, char *args)
/**** execute
	call an external program, return 0, if there was no error.
****/
{	int l=(int)strlen(name),gem,res;
	struct { char l; char s[512]; } command;
	int xt,yt,ht,wt,xg,yg,hg,wg;
	strcpy(command.s,args);
	command.l=(char)strlen(args);
	if (l<5) return -1;
	if (!in_text) text_mode();
	if (!editor)
	{	wind_update(END_UPDATE);
		graf_mouse(M_ON,0);
	}
	wind_get(twi_handle,WF_CURRXYWH,&xt,&yt,&wt,&ht);
	wind_get(gwi_handle,WF_CURRXYWH,&xg,&yg,&wg,&hg);
	wind_close(twi_handle); wind_close(gwi_handle);
	wind_delete(twi_handle); wind_delete(gwi_handle);
	menu_bar(menu_tree,0);
	gem=(strcmp(name+l-4,".prg")==0 || strcmp(name+l-4,".app") ||
		strcmp(name+l-4,".PRG")==0 || strcmp(name+l-4,".APP")==0);
	if (!gem)
	{	graf_mouse(M_OFF,0);
		printf("\x1B""E\x1B""e");
	}
	res=(int)Pexec(0,name,(COMMAND *)&command,(char *)0);
	if (!gem)
	{	graf_mouse(M_ON,0);
		printf("\x1B""f");
	}
	graf_mouse(M_OFF,0);
	menu_bar(menu_tree,1);
	redraw_all(); scan_events();
	if ((twi_handle=wind_create(telements,
			xdesk,ydesk,wdesk,hdesk))<0)
	{ form_alert(1,"[3][Kein Fenster mehr frei][Abbruch]"); exit(1);}
	if ((gwi_handle=wind_create(gelements,
			xdesk,ydesk,wdesk,hdesk))<0)
	{ form_alert(1,"[3][Kein Fenster mehr frei][Abbruch]"); exit(1);}
	wind_set(twi_handle,WF_NAME," Dialog ",0,0); /* Infozeile */
	wind_set(gwi_handle,WF_NAME," Graphics ",0,0); /* Infozeile */
	wind_open(gwi_handle,xg,yg,wg,hg); /* Oeffne Fenster */
	wind_open(twi_handle,xt,yt,wt,ht); /* Oeffne Fenster */
	graf_mouse(M_ON,0);
	scan_events();
	if (!editor)
	{	wind_update(BEG_UPDATE);
		graf_mouse(M_OFF,0);
	}
	return res;
}

int main (int argc, char *argv[])
{	/* init GEM */
	configpath[0]=Dgetdrv()+'A'; configpath[1]=':';
	Dgetpath(configpath+2,0);
	strcat(configpath,"\\euler.win");
	if (!open_vwork()) exit(1);
	if (!memory_init()) exit(1);
	if (rsrc_load("euler.rsc")==0)  /* Resource laden */
	{	form_alert(1,"[3][Resource nicht gefunden][Abbruch]");
		close_vwork();
		exit(1);
	}
	if (rsrc_gaddr(R_TREE,MENU,&menu_tree)==0) return 1;
	graf_mouse(ARROW,0); /* Maus ist Pfeil */
	graf_mouse(M_OFF,0);
	wind_update(BEG_UPDATE);
	menu_bar(menu_tree,1); /* Zeichne Menue */
	if (open_windows()) return 1; /* Oeffne Fenster */
	graphic_mode(); clear_graphics();
	text_mode(); clear_screen();
	graf_mouse(BUSYBEE,0); graf_mouse(M_ON,0);
	init_pattern();
	graf_mouse(ARROW,0); graf_mouse(M_OFF,0);
	main_loop(argc,argv);
	menu_bar(menu_tree,0);
	close_vwork();
	return 0;
}
