
**********************************************************
* SCHONASM.S                                             *
**********************************************************
* Assemblermodul zum Schoner                             *
**********************************************************
* (C)1993 by Stefan Becker. Assembler: Pure-Asm. Tab: 10 *
**********************************************************

RS232F    EQU       $130                * RS232-Buffer-Full

          EXPORT    act_flag            * Flagge auch fr PC erreichbar machen
          EXPORT    init_trap           * Routine zum Aktivieren der Traps

init_trap:movem.l   d0-d7/a0-a6,-(a7)   * Register retten

          move.w    #$22,-(a7)          * Kdvbase
          trap      #14                 * Xbios
          addq.l    #2,a7               * Stack aufrumen
          move.l    d0,ikbd             * Ergebnis merken

          pea       sup_stuff           * Diese Routine ausfhren
          move.w    #$26,-(a7)          * Supexec
          trap      #14                 * Xbios
          addq.l    #6,sp               * Stack wieder aufrumen

          movem.l   (a7)+,d0-d7/a0-a6   * Register restaurieren
          rts                           * Fertig.

*
* Diese Routine soll im Supervisormode ausgefhrt werden:
*

sup_stuff:move.l    ikbd,a0             * ^KBDVECS
wait1:    tst.w     36(a0)              * Busy?
          bne       wait1               * Warten bis Paket verschickt

          move.w    sr,d0               * CPU-Status merken
          or.w      #$2700,sr           * Interrupts sperren!

          tst.w     36(a0)              * Tatschlich kein Paket mehr?
          beq       okay                * Ja ja, alles in Ordnung!

          move.w    d0,sr               * Argh! Na gut! Interrupts frei ...
          bra       wait1               * ... und auf einen neuen Versuch!

okay:     move.l    32(a0),old_key      * Ikbdsys: Alte Adresse merken
          move.l    #my_key,32(a0)      * Neue Adresse eintragen

          move.l    24(a0),old_joy      * Joyvec
          move.l    #my_joy,24(a0)

          move.l    16(a0),old_mouse    * Mousevec
          move.l    #my_mouse,16(a0)

          move.l    RS232F,old_rs232    * RS232-Full
          move.l    #my_rs232,RS232F

          move.w    d0,sr               * Interrupts wieder freigeben.
          rts                           * Fertig.

*
* Eigene Ikbdsys-Routine:
*

          dc.b      "XBRA"              * Das sowieso!
          dc.b      "SCHO"              * Schoner was here!
old_key:  dc.l      0

my_key:   move.w    #$FFFF,act_flag     * Hier war was!
          move.l    old_key,-(a7)       * Alte Adresse.
          rts                           * Dort geht's weiter.
*
* Eigene Joy-Routine:
*

          dc.b      "XBRA"              * Das sowieso!
          dc.b      "SCHO"              * Schoner was here!
old_joy:  dc.l      0

my_joy:   move.w    #$FFFF,act_flag     * Hier war was!
          move.l    old_joy,-(a7)       * Alte Adresse.
          rts                           * Dort geht's weiter.

*
* Eigene Maus-Routine:
*

          dc.b      "XBRA"              * Das sowieso!
          dc.b      "SCHO"              * Schoner was here!
old_mouse:dc.l      0

my_mouse: move.w    #$FFFF,act_flag     * Hier war was!
          move.l    old_mouse,-(a7)     * Alte Adresse.
          rts                           * Dort geht's weiter.

*
* Eigene RS232-Full-Routine
*

          dc.b      "XBRA"              * Das sowieso!
          dc.b      "SCHO"              * Schoner was here!
old_rs232:dc.l      0

my_rs232: move.w    #$FFFF,act_flag     * Hier war was!
          move.l    old_rs232,-(a7)     * Alte Adresse.
          rts                           * Dort geht's weiter.

***************
* BSS-Segment *
***************

          bss

ikbd:     ds.l      1         * ^Inkbdsys-Struktur
act_flag: ds.w      1         * Flagge: 1, falls IKBD-Paket
                              * durchgekommen ist. => Schnell aufwachen!!!

***********************
* Ende von SCHONASM.S *
***********************

