/*
	(c) 1993/1994 by TMMW Morus Walter
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gem.h>
#include <vdi.h>

#include <portab.h>
#include <mglobal.h>
#include <mydial.h>
#include <nkcc.h>

#define RET_OK		1
#define RET_ERROR	0			/* rckgabewerte von funktionen */
#define RET_MEM		-1
#define RET_FORMAT	-2
#define RET_TYP		-3
#define RET_INIT	-4
#define RET_SIZE	-5

typedef unsigned int	uint;

typedef enum		/* fehlermeldungen */
{
	ERR_MEM=0,		/* speicherfehler */
	ERR_WINDOW,		/* kein fenster mglich */
	ERR_PICWIND,	/* kein bildfenster mglich */
	ERR_DELETE,		/* delete unmglich wegen offener Fenster */
	ERR_DEL_FILM,	/* 					wegen filmen */
	ERR_DEL_EF,		/* 					wegen film im film-editor */
	ERR_IMGSIZE,	/* image zu gro */
	ERR_BLOCK,		/* kein block */
	ERR_KONST,		/* konstante nicht sichtbar */
	ERR_HELP,		/* helpfile nicht gefunden */
	ERR_FILM,		/* film zu lang */
	ERR_FILM_EMPTY,	/* film leer */
	ERR_PRINTER,	/* drucker nicht bereit */
	ERR_SCALE,		/* bild wird beim skalieren zu klein */
	ERR_SIZE,		/* bild ist zu klein fr object */
	ERR_OBJC,		/* keine objekte mehr mglich */
	ERR_,
} ERRORS;

typedef struct		/* struktur fr fehlertexte */
{
	char *err1;
	char *err2;
	char *err3;
} ERR;

typedef struct		/* fr position von dialogen */
{
	int x;
	int y;
} DIAL_POS;

/*------------------------------------------------------------------------------

	einstellungen

------------------------------------------------------------------------------*/
#define MAX_PICSWINDS	8		/* maximale zahl an bild(er) fenstern */
#define MAX_WINDS		8		/* maximale zahl an fenstern */

typedef struct {		/* anzeigeflags */
	unsigned	compare		: 2; /* 0 And	 1 Or   2 Xor */
	unsigned	wait 		: 1; /* 1 warten auf taste  0 zeit */
	unsigned	richtung	: 1; /* 0 vorwrts		1 vor und zurck */
	unsigned	repeat		: 1; /* 0 einmal		1 wiederholt */
} AO_FLAGS;

typedef struct {		/* anzeigeoptionen */
	AO_FLAGS	flags;
	unsigned	wait_pic;
	unsigned	wait_end;
} SHOW_OPTS;

typedef enum {			/* konvertierungs-flags */
	NICHT_KONVERTIERT=0,
	X_BITMAP,
	FS_RASTER,
	DITHER,
} KONV_FLAG;

typedef enum {
	ABSOLUT,
	RELATIV,
} SET_SCHWELLE;

typedef enum {
	_RGB,
	_HLS,
	_IGNORE
} KONV_COL;

typedef enum {
	S_RASTER,
	S_NO_RASTER,
}  SCALE_FLAG;

typedef struct {		/* konvertierungs-parameter */
	SCALE_FLAG	r_scale;
	int			scale;
	KONV_FLAG	flag;
	KONV_COL	color;
	SET_SCHWELLE schwelle;
	int			bitmaps;
	int 		raster;		/* 1,2,3,4 fr NxN-Raster */
	int 		errdif;		/* zahl der punkte */
	int			dither;		/* unused */
} KONV_INFO;

typedef struct {
	uint	mem_rest;		/* speicher, der nicht belegt werden soll */
	uint	page_size;		/* jeweils in kByte!! */
	char	path[64];
	char	save;			/* meldung vor save */
	char	w_save;			/* warnung vor berschreiben */
	char	w_abbr;			/* warnung bei abbruch */
	char	w_del;			/* warnung vor lschen (nie, neue, mehrere, immer) */
	char    w_quit;			/* warnung vor beenden (nie, neue, immer) */
	char	gong;			/* flag, ob gong ein/aus */
	char	dr_flag;		/* 0 -> drucke mit TOS, 1 -> ass.-routine */
	char	pack;			/* 0 -> bilder nicht packen, 1 -> bilder packen */
	char	dialwind;		/* 0 -> keine dialogfenster, 1 -> dialogfenster */
	char	dialcenter;		/* 0 -> alte position, 1 -> zentrieren */
	char	infowind;		/* 0 -> keine dialogfenster, 1 -> dialogfenster */
	char	infocenter;		/* 0 -> alte position, 1 -> zentrieren, 2 -> rechts oben */
	char	show_scr_bk;	/* 0 wei, 1 grau, 2 schwarz, hintergrund beim anzeigen auf screen */
	char	show_wind_bk;	/* 0 wei, 1 grau, 2 schwarz, hintergrund in bildfenstern */
	char	comp_pos;		/* 0 zentriert 1 ecke */
	char	comp_mode;		/* 0 xor 1 or 2 and */
	char	do_draw;		/* 1 beim zeichnen ausgeben, 0 nicht ausgeben */
	char	do_buffer;		/* 1 ausgabe puffern, 0 sofort ausgeben */
	char	set_colors;		/* 0 nicht setzen,  1 bei dialogaufruf,  2 bei maus auerhalb fenster */
	int		max_film_len;
	SHOW_OPTS show_opts;
	KONV_INFO show_konv;	/* konvertieren bei anzeige */
	KONV_INFO konv_info;
	char	koord_flag;
	char	dummy1;
	char	dummy[32-18-2];	/* fr erweiterungen */
	GRECT	desk_wind;
	GRECT	pics_wind[MAX_PICSWINDS];	/* MAX_PICSWINDS==8 (im moment) */
	DIAL_POS copyrght;		/* mu erste position sein (fr scalieren!!) */
	DIAL_POS cpyrght2;
	DIAL_POS cpyrght3;
	DIAL_POS cpyrght4;
	DIAL_POS do_help;
	DIAL_POS dt_help;
	DIAL_POS xpack;
	DIAL_POS do_pack;
	DIAL_POS meminfo;
	DIAL_POS showopt;
	DIAL_POS compare;
	DIAL_POS allg_par;
	DIAL_POS make_inf;
	DIAL_POS allg_info;
	DIAL_POS aratio;
	DIAL_POS einst1;
	DIAL_POS einst2;
	DIAL_POS colors;
	DIAL_POS pic_info;
	DIAL_POS ld_error;
	DIAL_POS xsave;
	DIAL_POS konvert;
	DIAL_POS nfilm;
	DIAL_POS film_ed;
	DIAL_POS error;			/* mu letzte position sein (fr scalieren!!) */
} CHS_INST;

/*--------------

	speicherverwaltung

--------------*/
typedef volatile struct
{
	long	len;
	long	*mother;
	char	data[];
} X_DATA;

typedef volatile X_DATA *X_DATA_P;

#define block_len(mem_ptr)	((mem_ptr)->len-8)

typedef enum
{
	X_RES_END=-1,	/* letzter eintrag, nicht verwendet */
	X_RES_EMPTY,	/* eintrag leer, kein speicher belegt (-> mem==0l) */
	X_RES_FREE,		/* eintrag KANN bevorzugt freigegeben werden */
	X_RES,			/* eintrag wird eigentlich gleich gebraucht kann aber freigeben werden */
	X_RES_BEL		/* eintrag wird gebraucht, kann nicht freigegeben werden */
} X_RES_MODE;
typedef struct
{
	X_RES_MODE	mode;
	X_DATA_P	mem;
} X_RES_DATA;
/*------------

	parameter fr neue bilder

---------------*/
typedef struct
{
	int min_width;
	int max_width;
	int min_height;
	int max_height;
	int min_col;
	int max_col;
	int raster;			/* flag! */
} LIMITS;

typedef struct
{
	int red;
	int green;
	int blue;
} COLOR;

typedef struct
{
	int			anz;
	char		name[10];
	int			width;
	int			height;
	int			planes;
	int			raster;	/* nur bei planes==1 mglich */
	int			colors;
	int			c_tab_flag;	/* 0 not set, >0 -> c_tab_flag colors in col_tab */
	X_DATA_P	col_tab;
} ALLG_PAR;

typedef struct
{
	X_DATA_P	sp;			/* zeiger auf spezielle parameter */
	ALLG_PAR	*ap;		/* zeiger auf allgemeine parameter */
	LIMITS		*limits;	/* zeiger auf beschrnkungen fr allg. parameter */
	long		size;		/* gre der bitmap */
	int			set_flag;	/* 0 -> hole parameter, 1 -> parameter voreinst., 2 -> neu param */
	int			local1;
	int			local2;
	int			local3;
} AP_DATA;

/*
		struktur fr berechnungsinfo anzeigen
*/
typedef struct
{
	int			width;		/* breite des bildes */
	int			height;		/* hhe des berechneten bildes */
	int			xheight;	/* bereits berechnete zeilen
								(-1, falls nicht zeilenweise berechnet wird) */
	long		iter;		/* zahl der bereits berechneten iterationen */
	long		iter_ges;	/* -1 -> unknown */
	long		time;
	int			time_iter;	/* -1 -> unknown */
	long		pkte;		/* -1 -> xheight*width */
	long		pkte_ges;	/* -1 -> height*width */

	int			key;
	int			state;
} MAKE_INFO;

typedef struct		/* fr info anzeigen */
{
	int		anz;
	double	points;
	double	time;
	double	iter;
} P_INFO;

#define UNPACKED		0
#define UNPACKABLE		1
#define PACKED			2

typedef struct
{
	X_DATA_P col_tab;
	X_DATA_P pic_data;

	int		width;		/* gre der bitmap!!! */
	int		height;
	int		xheight;	/* ex. zeilen (u.U. <height) */
	int		planes;
	int		colors;		/* zahl der farben in col_tab */

	char	packed;		/* UNPACKED, UNPACKABLE, PACKED */
	char    raster;		/* 1, 2, 4 */

	int     xor_offset;	/* BYTE */
	long 	pic_len;
} BITMAP;

typedef struct
{
	long null1;		/* mu 0 sein (in bitmap X_DATA_P!) */
	long null2;		/* mu 0 sein (in pic_data X_DATA_P!) */
	SHOW_OPTS	opts;
	int			pic_anz;
} FILM;

typedef union {
	BITMAP	bitmap;
	FILM	film;
} X_OBJC;

typedef struct
{
	int		nr;			/* nummer des objectes */
	int		typ;		/* object-typ: 0 film  1 pic  2... fractale */
	int		objc_flag;	/* flag fr icon */
	int		objc_state;	/* status fr icon */
	char	name[10];	/* name des objectes */
	char	path[40];	/* pfad des objectes */
	char	ext[4];		/* extension */

	X_OBJC  x;

	X_DATA_P param;
	X_DATA_P x_param;
} CHS_OBJC;

#define _GET_OBJC		1	/* flags/rckgabewerte fr get_object */
#define _GET_BLOCK		2
#define _GET_KONST		4
#define _GET_ALL		(_GET_OBJC|_GET_BLOCK|_GET_KONST)
#define _GET_OBJCS		8	/* bereich zurckgeben */
#define _GET_RBLOCK		16	/* Rotated BLOCKs */
#define _ALL_PICS		-1


typedef struct
{
	CHS_OBJC *ob;
	CHS_OBJC *ob2;
	double xmin;			/* mu ab hier mit R_REC bereinstimmen */
	double xmax;			/* war zu faul, eine substruktur einzufhren! */
	double ymin;
	double ymax;
	double phi;
	int wh_valid;	/* magic: 'MW' */
	int width;		/* fr aspect ratio bei block */
	int height;		/* fr aspect ratio bei block */
} GET_DATA;

typedef struct {
	double xmin;
	double xmax;
	double ymin;
	double ymax;
	double phi;
} R_REC;

typedef struct {
	double xdx;
	double xdy;
	double ydx;
	double ydy;
	double x0;
	double y0;
} R_REC_DXY;

typedef struct {
	double x_lo;
	double y_lo;
	double x_lu;
	double y_lu;
	double x_ro;
	double y_ro;
	double x_ru;
	double y_ru;
} EDGES;

typedef struct {
	char str[5][128];
} DR_INFO;

typedef struct {
	char id[8];
	uint par_len;
	void (*conv_param)(void *out,void *in,X_DATA_P *x_param,BITMAP *bitmap);
} _X_TYP;

typedef struct 
{
	int anzahl;
	_X_TYP *x_typ;
} X_TYP;

typedef struct
{
	ICONBLK *icon;		/* zeiger auf icon */
	char *typ;
	char last_flag;		/* ==1 -> xheight (>0, <height) entspricht ber. graph. zeilen
						   ==0 -> immer ganzen screen speichern */
	char block_flag;	/* 1 -> block kann in bild markiert werden */

	int (*show_par)(CHS_OBJC *ob);
	void (*show_info)(CHS_OBJC *ob);
	void (*get_info)(CHS_OBJC *ob,P_INFO *pi);

	void (*get_objcblk)(CHS_OBJC *objc,R_REC *r);
	void (*get_konst)(CHS_OBJC *objc,double *x,double *y);
	void (*pkt_info)(CHS_OBJC *object,int x,int y);

	void (*get_dr_info)(CHS_OBJC *object,DR_INFO *di);

	long	dummy1;
	long	dummy2;
	long	dummy3;
	long	dummy4;
} CHAOS_2;

typedef struct Chaos_1
{
	char id[8];		/* kennung der routine,
						gedacht:	4 zeichen fr autor
									4 zeichen fr routine */

	char *menue;		/* meneintrag
							max. 16 zeichen */
	char *name;			/* name des autors fr programm-info anzeigen
							max. 24 zeichen */
	char *version;		/* versionsnummer (und datum) der routine
							max. 20 zeichen */
	char *text;			/* allg. beschreibung oder sonst. kommentar
							max. 64 zeichen */

	uint set_len;		/* lnge der voreinstellungen */
	void *set;			/* zeiger auf speicherbereich fr fr voreinstellungen,
							mu routine bereitstellen! */
	ALLG_PAR *allg_par;	/* zeiger auf speicherbereich fr allg. param */


	uint par_len;		/* lnge der bild-parameter */
	uint make_len;		/* lnge der eingabeparameter fr make bild(er) */
	uint neu_len;		/* lnge fr parameter bei make_neu */
	X_DATA_P *neu_par;	/* zeiger auf make_neu-parameter,
	 						von make_neu-routine zu setzen */
	int neu_flag;		/* flag fr make neu:
							-2 kein neu mglich!
							0 not set, 1 neu ok, -1 nicht neu (abbruch in dialog) */

	char xor_lines;		/* ZEILEN (PUNKT, nicht PIXEL) */
	char xget_flag;		/* mgliche vorgaben (wie get_object)! */

	LIMITS limits;

	X_RES_DATA *x_mem;

	int (*do_init)(int typ);

	int (*get_param)(int typ,AP_DATA *ad,int mode,int ks,GET_DATA *gd);
	void *(*get_picpar)(int typ,void *param_in,int nr,int anzahl);
	void (*set_param)(int typ,AP_DATA *ad);
	void (*extended)(int typ);

	int (*do_draw)(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight);
	int (*dont_draw)(CHS_OBJC *objc);

	int (*get_neu_param)(int typ,X_DATA_P *param,ALLG_PAR *ap);
	void *(*make_neu_param)(CHS_OBJC *objc,void *param,int *change);
	void (*xneu_param)(CHS_OBJC *objc);
	void (*conv_param)(void *param,void (*conv_dpos)(DIAL_POS *dp));

	X_TYP *x_typ;

	long	dummy1;
	long	dummy2;
	long	dummy3;
	long	dummy4;	/* dummies mssen 0 sein! */
} CHAOS_1;

#define CHAOS_INS_ID "CHSultd"
#define X_CHAOS_ID	"CHSultdG"
#define X__CHAOS_ID	"CHSultdg"
#define CHS_VERSION	0x0640

typedef struct
{
	char id[8];			/* X_CHAOS_ID */
	int chs_version;	/* version der erwarteten schnittstelle */
	int anz;
	CHAOS_1 *chs1;
	CHAOS_2 *chs2;
} X_CHAOS;

typedef struct
{
	char id[8];			/* X__CHAOS_ID */
	int chs_version;	/* version der erwarteten schnittstelle */
	int anz;
	CHAOS_1 **chs1;
	CHAOS_2 **chs2;
} X__CHAOS;

typedef struct {
	char chs_id[8];		/* X_CHAOS_ID */
	int  chs_version;	/* version der erwarteten schnittstelle */
	long hcopy_id;		/* 'HCPY' */
	char id[8];			/* kennung der routine, (ntig fr save settings)
							gedacht: 4 zeichen fr autor
									 4 zeichen fr routine */

	char *text;			/* unter anderem fr init-dialog
							max. 32 zeichen */
	char *name;			/* name des autors fr programm-info anzeigen
							max. 24 zeichen */
	char *version;		/* versionsnummer (und datum) der routine
							max. 20 zeichen */

	int (*do_init)(void);
	void (*hardcopy)(int ks,int dm,void *pw,int objc);
	void (*dr_param)(void);

	void (*conv_param)(void *param,void (*conv_dpos)(DIAL_POS *dp));
				/*
					konvertiere parameter fr load/save
						(normalisieren der positionen)
				*/

	uint set_len;
	void *set;
	long dummy0;
	long dummy1;
	long dummy2;
	long dummy3;
} CHS_PRN;

/*------------------------------------------------------------------------------
	routinen fr jedermann (zugnglich ber structur COMMON)
------------------------------------------------------------------------------*/
typedef void (*_get_rkoord)(int *rx,int *ry,double x,double y);

typedef void (*_draw_pkt)(int x,int y,int col);
typedef void (*_xdraw_pkt)(int col);
typedef int (*_get_pkt)(int x,int y);

enum {						/* rckgabewerte fr lr-popup */
	_PLR_DEL,
	_PLR_GET,
	_PLR_RND,
	_PLR_DUMMY,
	_PLR_ARATIO
};

#define _PLR__DEL	1		/* flags fr lr-popup */
#define _PLR__GET	2
#define _PLR__RND	4
#define _PLR__DUMMY	8
#define _PLR__ARATIO 16

enum {						/* rckgabewerte fr all-popup */
	_PA_DEL,
	_PA_INST,
	_PA_LR
};
typedef enum
{
	GET_ALL,
	GET_PICS,
	GET_FRACTAL,
	GET_NEU,
	GET_UNREADY,
	GET_FINFO,
	GET_SPAR,
	GET_BLOCK,
	GET_GBLOCK,
	GET_FILM,
} OB_MODE;

#define DRAWMODE_SET		0	/* pixel nur setzen */
#define DRAWMODE_REPLACE	1	/* pixel setzen und lschen */
#define DRAW_NOPUFFER		0	/* maximaler puffer */
#define DRAW_MAXPUFFER		-1	/* maximaler puffer */

typedef struct
{
	int version;			/* CHS_VERSION */

			/* MyDial-Routinen (genaue Beschreibung siehe MyDial.TXT) */
			/*--------------------------------------------------------*/
	void (*dial_fix)(OBJECT  *tree,BOOLEAN is_dialog);
	long (*get_obspec)(OBJECT *tree, WORD obj);
	void (*set_obspec)(OBJECT *tree, WORD obj, LONG obspec);

			/* (MyDial) popup-mens */
			/*----------------------*/
	int (*popup_select)(OBJECT *dialtree, WORD btn, OBJECT *poptree, WORD obj, BOOLEAN docheck, WORD docycle, BOOLEAN *ok);
	int (*popup_menu)(OBJECT *tree, WORD obj, WORD x, WORD y, WORD center_obj, BOOLEAN relative, WORD bmsk, BOOLEAN *ok);

			/* (MyDial) alert-boxen */
			/*----------------------*/
				/* ber die MyDial-Routinen hinaus wird gegebenfalls
				   die Farbtabelle fr den Aufruf gendert
				*/
	int (*do_alert)(int defbut, CONST char *txt);
	int (*dial_alert)(BITBLK *alicon,CONST char *string,int defbut,int undobut,int align);

			/* dialogboxen */
			/*-------------*/
	int (*xdialwind)(int flag,OBJECT *objc,DIAL_POS *ob_pos,int ob_nr,int (*do_exit)(int objc,void *data,void *dw),void *data,int *redraw,char *help_file);
	void (*xredraw_dialwind)(int objc,int flag,void *_dw);

			/* info-dialoge */
			/*--------------*/
	int (*init_infodial)(OBJECT *objc,DIAL_POS *ob_pos,int flag);
	int (*exit_infodial)(void);						/* returns: redraw */
	void (*redraw_infodial)(int objc);
	void (*init_xinfo)(char *titel,char *text,int esc_flag);
	void (*exit_xinfo)(void);

			/* spezielle dialoge */
			/*-------------------*/
	int (*do_error)(int nr,int mode,int wind);
	void (*do_help)(char *name,int flag,int *redraw);
	int (*fsel)(char *path,char *sel,int *button,char *label);

			/* alert-/ error-aufrufe von zeichenroutinen aus (MAUSZEIGER...) */
			/*---------------------------------------------------------------*/
	int (*make_error)(int nr,int mode,int wind);
	int (*make_alert)(int defbut, CONST char *txt);
					/* zeige alert box an (MyDial-Routine) analog form_alert */
					/* zu verwenden whrend berechnung!! (mauszeiger!!) */

			/* hilfsroutinen fr parametereingabe */
			/*------------------------------------*/
	int (*get_allg_par)(AP_DATA *ad,int typ);
	void (*set_ipol_pbutton)(OBJECT *tree,int object,int value,int mode);
	int	(*get_ipol_pbutton)(OBJECT *tree,int object,int mode);
	void (*do_ipol_pbutton)(OBJECT *tree,int object,int mode,int cycle,int *ok);
	void (*write_ap_info)(OBJECT *tree,int object,ALLG_PAR *ap);
	int (*show_aratio)(ALLG_PAR *ap,OBJECT *tree,int ob_xmin,int ob_xmax,int ob_ymin,int ob_ymax,int *ok);
	int (*do_get_popup)(OBJECT *tree,int object,int mode,int *ok);
	void (*conv_sc_mm)(double scale,double offset,int delta,double *min,double *max);
	void (*conv_mm_sc)(double min,double max,int delta,double *scale,double *offset);

	int (*xsel_load)(char *ext,char *titel,X_DATA_P *mem,long *off,int *ok);

			/* zufallszahlen */
			/*---------------*/
	long (*irand)(long dummy);
	double (*xrand)(long dummy);

			/* interpolation */
			/*---------------*/
	double (*ipol)(double anf,double end,int x,int cnt,int flag);
	void (*xipol)(double anf1,double end1,double anf2,double end2,double *anf,double *end,int act,int n);

			/* daten aus objecten holen */
			/*--------------------------*/
	int (*get_object)(int mode,int typ,GET_DATA *gd,char *info_str);
	int (*get_obblk)(CHS_OBJC *objc,R_REC *r);
	int (*get_std_planes)(BITMAP *bitmap,MFDB *dest,X_DATA_P *mem,int h_flag,int planes);

			/* tastatur abfragen */
			/*-------------------*/
	int (*check_key)(MAKE_INFO *mi);

			/* punkt-setz-routinen */
			/*---------------------*/
	_draw_pkt (*init_draw)(BITMAP *bitmap,int mode,int puffer);
	_xdraw_pkt (*init_xdraw)(BITMAP *bitmap,int x,int y,int mode,int puffer);
	void (*clr_pktpuffer)(void);
	void (*flush_pktpuffer)(void);
	void (*clr_screen)(void);		/* lscht nur anzeigebildschirm, nicht bitmap */
	void (*draw_line)(int X1, int Y1, int X2, int Y2, int color,_draw_pkt draw);

	_get_pkt (*init_getpkt)(BITMAP *bitmap);

			/* timer-routinen */
			/*----------------*/
	long (*gettime)(void);
					/* 200Hz-zhler auslesen */
	void (*conv_time)(unsigned long ms,int *h,int *m,double *s);
					/* zeit umwandeln
						ms (millisekunden)
							-> h (stunden),m (minuten),s (sekunden)
					*/

			/* objectstatus ndern */
			/*---------------------*/
				/* ndere objektstatus */
	void (*set_unready)(CHS_OBJC *objc);
					/* zu unfertig */
	void (*set_ready)(CHS_OBJC *objc);
					/* zu fertig */
				/* ES IST PRINZIPIELL NICHT ZULSSIG, DIREKT AM STATUS EINES
					OBJEKTES (durch zugriff auf objc_flag, objc_state in der
					CHS_OBJC-struktur) ZU NDERN!!!
				*/

			/* speicher-verwaltung */
			/*---------------------*/
	int (*x_malloc)(long len,X_DATA_P *mother);
	int (*x_mshrink)(X_DATA_P *data,long new_len);
	int (*x_mfree)(X_DATA_P *data);
	int (*x_ch_mem)(X_DATA_P *new,X_DATA_P *old);

			/* printf...-routinen */
			/*--------------------*/
	void (*write_double)(char *s,double z,int l,int p);
	int (*sprintf)( char *string, const char *format, ... );
	int (*sscanf)( const char *string, const char *format, ... );
	int (*fprintf)( FILE *file, const char *format, ... );
	int (*fscanf)( FILE *file, const char *format, ... );

			/* 32-bit fixkomma-arithmetik */
			/*----------------------------*/
	long (*mult32)(long a,long b);
	long (*quad32)(long a);

	long (*multiply)(long a,long b,int n);
	long (*divide)(long a,long b,int n);
	long (*add)(long a,long b);
	int  overflow;
	void (*sincos68)(long phi,long *s,long *c);
	long (*stackavail)(void);

			/* einstellungen */
			/*---------------*/
	CHS_INST *inst;

			/* unterstzung fr hardcopy-routinen */
			/*------------------------------------*/
	CHS_OBJC *(*first_ob)(OB_MODE mode,int ks,int dm,void *pw,int objc);
	CHS_OBJC *(*next_ob)(void);
	int (*check_printer)(void);
	void (*pr_byte)(char byte);
	void (*pr_bytes)(char *byte,long len);
	int (*get_dr_info)(CHS_OBJC *objc,DR_INFO *dr);

			/* aes-funktionen */
			/*----------------*/
	int (*rsrc_load)(const char *path);
	int (*rsrc_gaddr)(int type,int index,void *addr);
	int (*objc_offset)(OBJECT *tree,int ob,int *x,int *y);
	int (*graf_mkstate)(int *,int *,int *,int *);

	void (*init_rrec)(R_REC_DXY *out,R_REC *in,int width,int height,int xheight,int flag);
	_get_rkoord (*init_rkoord)(R_REC *in,int width,int height);

	void (*maus_busy)(MFORM *mform);
	void (*maus_unbusy)(int flag);

	int (*get_konv_info)(KONV_INFO *ki,char *info,char *titel,int *ok);
	void (*make_konv_str)(KONV_INFO *ki,int planes,char *str1,char *str2);

	int (*get_hcopy_planes)(KONV_INFO *ki,CHS_OBJC *ob,MFDB *dest,X_DATA_P *mem,X_DATA_P *c_tab,int max_planes);

	long dummy0;
	long dummy1;
	long dummy2;
	long dummy3;
	long dummy4;
	long dummy5;
	long dummy6;
	long dummy7;
	long dummy8;
	long dummy9;
	long dummyA;
	long dummyB;
	long dummyC;
	long dummyD;
	long dummyE;
 	long dummyF;
} COMMON;
