/*
	(c) 1993/1994 by TMMW Morus Walter
*/
#include <math.h>
#include "..\common.h"
#include "..\chs_ultd.gem\feigenbm.h"


/*------------------------------------------------------------------------------
		strings
------------------------------------------------------------------------------*/
static char fgbm_parameter[]="Feigenbaum-Parameter";
static char fg_dr_string1[]="Parameter   r: %-14s - %-14s";
static char fg_dr_string2[]="Funktionswert: %-14s - %-14s, Startwert %-14s";
static char fg_dr_string3[]="Iterationen  : %6d vor, %6d bei Plot (Schrittweite %d)";
static char fgbm_menue[]="Feigenbaum-Diag.";
static char fgbm_date[]="V2.0, 18. 7.1993";
static char fgbm_text[]="Feigenbaum Diagramme";
/*------------------------------------------------------------------------------
		initialisierungsroutine,
			mu nach linken am anfang des text-segmentes stehen,
			d.h. im quelltext ganz vorne
------------------------------------------------------------------------------*/
static COMMON	*common;			/* zeiger fr die routinen von chaos */

int errno;				/* damit der linker nicht motzt;
							sonst in pc_start deklariert */

X_CHAOS *ret_fgbm(COMMON *com)
{
extern X_CHAOS xfch;

	common=com;				/* merke com */
	return &xfch;				/* gib eigene routinen zurck */
}

/*------------------------------------------------------------------------------

	parameterstrukturen

------------------------------------------------------------------------------*/
/*
		bildparameter
*/
typedef struct
{
	int flag;			/* 0 quer, 1 hoch */

	int n1;				/* iterationen vor plot */
	int n2;				/* iterationen fr plot */
	int dn;				/* iterationen zwischen zwei plot's */

	long time;			/* rechenzeit */
	long pkte;
	int	last;

	double r_min;		/* definition des rechteckes */
	double r_max;
	double y_min;
	double y_max;

	double y0;			/* startwert fr iteration */
} FEIGENBAUM;

/*
		bild(er)parameter fr neu bilder
*/
typedef struct
{
	FEIGENBAUM start;	/* parameter des ersten bildes */
	FEIGENBAUM end;		/* parameter des letzten bildes */
	int change[8];		/* interpolationstypen */
	FEIGENBAUM act;		/* speicherplatz fr parameter des aktuellen bildes */
} FGBM_PAR;

/*
		einstellungen
*/
typedef struct
{
	FEIGENBAUM start;
	FEIGENBAUM end;
	int change[8];
	DIAL_POS	param;	/* first */
	DIAL_POS	spar;	/* last */
} FGBM_SET;

/*------------------------------------------------------------------------------

	globale variable

------------------------------------------------------------------------------*/
static int	fgbm_typ;					/* nummer der routine in chaos */

static OBJECT *fg_par_ad,*fg_show_ad;	/* dialogboxen */

FGBM_SET fgbm_set=						/* einstellungen */
{
   {0,100,250,1,
	0l,0l,0,
	1.0,4.0,0.0,1.0,0.5},
   {0,100,250,1,
	0l,0l,0,
	1.0,4.0,0.0,1.0,0.5},
   {1,1,1,1,1,1,1,1},
};

ALLG_PAR fgbm_apar={1,"FEIGENBM",640,400,1,0,2};

/*------------------------------------------------------------------------------

		parameter einlesen

------------------------------------------------------------------------------*/
/*
		indizes der dialogbox-elemente
*/
		/* button fr interpolation */
static int fb_ch[]={FB_RMIN,FB_RMAX,FB_XMIN,FB_XMAX,FB_X0,FB_N1,FB_N2,FB_DN};
		/* redraw-objc fr interpolation */
static int fb_xch[]={FB_1,FB_1,FB_2,FB_2,FB_2,FB_3,FB_3,FB_DN};
		/* tedinfo's der start-parameter */
static int fb_1[]={FB_RMIN1,FB_RMAX1,FB_XMIN1,FB_XMAX1,FB_X0_1,FB_N1_1,FB_N2_1,FB_DN_1};
		/* tedinfo's der end-parameter */
static int fb_2[]={FB_RMIN2,FB_RMAX2,FB_XMIN2,FB_XMAX2,FB_X0_2,FB_N1_2,FB_N2_2,FB_DN_2};

/*
		belege dialogbox vor
*/
static void set_fgparam(FGBM_SET *set,AP_DATA *ad)
{
int i;

		/* info ber name & bitmap */
	common->write_ap_info(fg_par_ad,FB_PINFO,ad->ap);

											/* parameter links */
	common->write_double(objc_tedstr(fg_par_ad,FB_RMIN1),set->start.r_min,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_RMAX1),set->start.r_max,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_XMIN1),set->start.y_min,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_XMAX1),set->start.y_max,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_X0_1),set->start.y0,15,11);
	common->sprintf(objc_tedstr(fg_par_ad,FB_N1_1),"%4d",set->start.n1);
	common->sprintf(objc_tedstr(fg_par_ad,FB_N2_1),"%4d",set->start.n2);
	common->sprintf(objc_tedstr(fg_par_ad,FB_DN_1),"%3d",set->start.dn);

											/* parameter rechts */
	common->write_double(objc_tedstr(fg_par_ad,FB_RMIN2),set->end.r_min,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_RMAX2),set->end.r_max,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_XMIN2),set->end.y_min,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_XMAX2),set->end.y_max,15,11);
	common->write_double(objc_tedstr(fg_par_ad,FB_X0_2),set->end.y0,15,11);
	common->sprintf(objc_tedstr(fg_par_ad,FB_N1_2),"%4d",set->end.n1);
	common->sprintf(objc_tedstr(fg_par_ad,FB_N2_2),"%4d",set->end.n2);
	common->sprintf(objc_tedstr(fg_par_ad,FB_DN_2),"%3d",set->end.dn);

	for( i=0; i<(int)(sizeof(fb_ch)/sizeof(fb_ch[0])); i++ )
		common->set_ipol_pbutton(fg_par_ad,fb_ch[i],set->change[i],0);

											/* bildtyp: normal/quer */
	objc_select(fg_par_ad,FB_NRM+set->start.flag);
	objc_unselect(fg_par_ad,FB_QUR-set->start.flag);
}

/*
		parameter aus dialogbox auslesen
*/
static int get_fgparam(AP_DATA *ad)
{
int i;
FGBM_PAR *param=(FGBM_PAR*)ad->sp->data;
												/* startparameter */
	common->sscanf(objc_tedstr(fg_par_ad,FB_RMIN1),"%lf",&param->start.r_min);
	common->sscanf(objc_tedstr(fg_par_ad,FB_RMAX1),"%lf",&param->start.r_max);
	if ( param->start.r_min>param->start.r_max )
		return FB_RMIN1;
	common->sscanf(objc_tedstr(fg_par_ad,FB_XMIN1),"%lf",&param->start.y_min);
	common->sscanf(objc_tedstr(fg_par_ad,FB_XMAX1),"%lf",&param->start.y_max);
	if ( param->start.y_min>param->start.y_max )
		return FB_XMIN1;
	common->sscanf(objc_tedstr(fg_par_ad,FB_X0_1),"%lf",&param->start.y0);
	common->sscanf(objc_tedstr(fg_par_ad,FB_N1_1),"%d",&param->start.n1);
	common->sscanf(objc_tedstr(fg_par_ad,FB_N2_1),"%d",&param->start.n2);
	common->sscanf(objc_tedstr(fg_par_ad,FB_DN_1),"%d",&param->start.dn);

												/* endparameter */
	common->sscanf(objc_tedstr(fg_par_ad,FB_RMIN2),"%lf",&param->end.r_min);
	common->sscanf(objc_tedstr(fg_par_ad,FB_RMAX2),"%lf",&param->end.r_max);
	if ( (ad->local2 || ad->ap->anz>1) && param->end.r_min>param->end.r_max )
		return FB_RMIN2;
	common->sscanf(objc_tedstr(fg_par_ad,FB_XMIN2),"%lf",&param->end.y_min);
	common->sscanf(objc_tedstr(fg_par_ad,FB_XMAX2),"%lf",&param->end.y_max);
	if ( (ad->local2 || ad->ap->anz>1) && param->end.y_min>param->end.y_max )
		return FB_XMIN2;
	common->sscanf(objc_tedstr(fg_par_ad,FB_X0_2),"%lf",&param->end.y0);
	common->sscanf(objc_tedstr(fg_par_ad,FB_N1_2),"%d",&param->end.n1);
	common->sscanf(objc_tedstr(fg_par_ad,FB_N2_2),"%d",&param->end.n2);
	common->sscanf(objc_tedstr(fg_par_ad,FB_DN_2),"%d",&param->end.dn);

	for( i=0; i<(int)(sizeof(fb_ch)/sizeof(fb_ch[0])); i++ )
		param->change[i]=common->get_ipol_pbutton(fg_par_ad,fb_ch[i],0);

	if ( objc_selected(fg_par_ad,FB_QUR) )					/* bildtyp */
		param->start.flag=1;
	else
		param->start.flag=0;

	return 0;
}

static int _do;

static int lr_popup(AP_DATA *ad,int object,int *ok)
{
int i;
int ret;
int *objcs;

	_do=0;
	ret=common->do_get_popup(fg_par_ad,object,_PLR__DEL|_PLR__GET,ok);

	if ( ret==-1 )
		return 0;
	if ( object==FB_LEFT )
		objcs=fb_1;
	else
		objcs=fb_2;

	if ( ret==_PLR_DEL ) {
		for ( i=0; i<(int)(sizeof(fb_1)/sizeof(fb_1[0])); i++ )
			*objc_tedstr(fg_par_ad,objcs[i])=0;
		*ok=0;			/* redraw */
	}
	else if ( ret==_PLR_GET )
		_do=1;

	return 1;
}

/*
		parameter / block aus objekt
*/
static void set_objc(int xmode,AP_DATA *ad,int *objcs,GET_DATA *gd)
	/* xmode=0 -> objc, =1 -> block, =2 -> pkt (->x0) */
{
FEIGENBAUM *fgbm;

	if ( gd->ob!=0l ) {
		fgbm=(FEIGENBAUM*)gd->ob->param->data;
		common->write_double(objc_tedstr(fg_par_ad,objcs[0]),fgbm->r_min,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[1]),fgbm->r_max,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[2]),fgbm->y_min,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[3]),fgbm->y_max,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[4]),fgbm->y0,15,11);
		common->sprintf(objc_tedstr(fg_par_ad,objcs[5]),"%4d",fgbm->n1);
		common->sprintf(objc_tedstr(fg_par_ad,objcs[6]),"%4d",fgbm->n2);
		common->sprintf(objc_tedstr(fg_par_ad,objcs[7]),"%3d",fgbm->dn);
		objc_select(fg_par_ad,FB_NRM+fgbm->flag);
		objc_unselect(fg_par_ad,FB_QUR-fgbm->flag);
	}
	if ( xmode==_GET_BLOCK ) {	/* block */
		common->write_double(objc_tedstr(fg_par_ad,objcs[0]),gd->xmin,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[1]),gd->xmax,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[2]),gd->ymin,15,11);
		common->write_double(objc_tedstr(fg_par_ad,objcs[3]),gd->ymax,15,11);
	}
	else if ( xmode==_GET_KONST ) {
		common->write_double(objc_tedstr(fg_par_ad,objcs[4]),gd->ymin,15,11);
	}
}

/*
		parameter eingeben
*/
static int par_button(int object,void *data,void *dw)
{
int ob;
int ok=1;
int i,ret;

	object&=0x7FFF;
	objc_unselect(fg_par_ad,object);
	if ( object==FB_ABBR || object==FB_APAR )
		return 0;
	else if ( object==FB_OK ) {
		ob=get_fgparam((AP_DATA*)data);
		if ( ob ) {
			*(int*)dw=ob;
			return FB_OK;
		}
		return 0;
	}
	else if ( object==FB_ALL ) {
		ret=common->do_get_popup(fg_par_ad,FB_ALL,0,&ok);
		if ( ret>=0 ) {
			if ( ret==_PA_DEL ) {
				for ( i=0; i<(int)(sizeof(fb_1)/sizeof(fb_1[0])); i++ ) {
					*objc_tedstr(fg_par_ad,fb_1[i])=0;
					*objc_tedstr(fg_par_ad,fb_2[i])=0;
				}
			}
			else if ( ret==_PA_INST ) {
			 	set_fgparam(&fgbm_set,(AP_DATA*)data);
			}
			else if ( ret==_PA_LR ) {
				for ( i=0; i<(int)(sizeof(fb_1)/sizeof(fb_1[0])); i++ ) {
					strcpy(objc_tedstr(fg_par_ad,fb_2[i]),
							objc_tedstr(fg_par_ad,fb_1[i]));;
				}
			}
			return -1;
		}
	}
		/* popup fr links/rechts */
	else if ( object==FB_LEFT || object==FB_RIGHT ) {
		lr_popup(data,object,&ok);
		if ( _do )
			return 0;
	}
	else {
	  int nr;
		for ( nr=0; nr<(int)(sizeof(fb_ch)/sizeof(fb_ch[0])); nr++ )
			if ( object==fb_ch[nr] || object==fb_ch[nr]+1 )
				break;
		if ( nr!=(int)(sizeof(fb_ch)/sizeof(fb_ch[0])) ) {
			common->do_ipol_pbutton(fg_par_ad,fb_ch[nr],0,
				object==fb_ch[nr]?DO_POPUP:DO_CYCLE,&ok);

			return ok ? fb_xch[nr] : -1;
		}
	}
	return ok ? -2 : -1;
}

static int do_fg_param(int hu_typ,AP_DATA *ad)
{
int ret;

	do {
		ret=common->xdialwind(1,fg_par_ad,&fgbm_set.param,FB_RMIN1,par_button,ad,(int*)-1l,"fg_param")&0x7FFF;
		if ( ret==FB_APAR ) {
			if ( common->get_allg_par(ad,fgbm_typ) )
				common->write_ap_info(fg_par_ad,FB_PINFO,ad->ap);
		}
		else if ( ret==FB_LEFT || ret==FB_RIGHT ) {
		  int mode;
		  GET_DATA gd;
		  int *objcs;

			gd.wh_valid='MW';
			gd.width=ad->ap->width;
			gd.height=ad->ap->height;
			mode=common->get_object(_GET_ALL,_ALL_PICS,&gd,fgbm_parameter);
			if ( ret==FB_LEFT )
				objcs=fb_1;
			else
				objcs=fb_2;

			if ( mode && gd.ob->typ!=fgbm_typ ) {
				if ( mode==_GET_OBJC ) {
					if ( common->get_obblk(gd.ob,(R_REC*)&gd.xmin) )
						mode=_GET_BLOCK;
					else
						mode=0;
				}
				gd.ob=0l;
			}
			if ( mode )
				set_objc(mode,ad,objcs,&gd);
		}
 	} while ( ret!=FB_OK && ret!=FB_ABBR );
 	if ( ret==FB_OK )
 		return 1;
 	else
		return 0;
}

static int fg_param(int typ,AP_DATA *ad,int mode,int ks,GET_DATA *gd)
{
	set_fgparam(&fgbm_set,ad);		/* schreibe voreinstellungen in dialog */
	if ( mode )
		set_objc(mode,ad,fb_1,gd);
	return do_fg_param(typ,ad);
}

/*
		voreinstellungen einlesen
*/
static void x_fg_param(int typ,AP_DATA *ad)
{
FGBM_PAR *param;
int i;

	ad->local2=1;
	if ( fg_param(typ,ad,0,0,0l) ) {		/* parameter einlesen */
		param=(FGBM_PAR*)ad->sp->data;
		fgbm_set.start=param->start;	/* nach fgbm_set kopieren */
		fgbm_set.end=param->end;
		for ( i=0; i<8; i++ )
			fgbm_set.change[i]=param->change[i];
	}
}

/*
		bild-parameter aus bild(er)-parametern erzeugen
*/
static FEIGENBAUM *fg_par(int typ,FGBM_PAR *in,int nr,int anz)
{
	anz--;	/* (die interpolations-routinen brauchen nicht anzahl sondern grt-mgliche nummer (also anzahl-1) */
	in->act=in->start;	/* erst mal alle parameter kopieren (so kann man nichts vergessen) */
					/* dann interpolieren wo ntig */
	in->act.r_min=common->ipol(in->start.r_min,in->end.r_min,nr,anz,in->change[0]);
	in->act.r_max=common->ipol(in->start.r_max,in->end.r_max,nr,anz,in->change[1]);
	in->act.y_min=common->ipol(in->start.y_min,in->end.y_min,nr,anz,in->change[2]);
	in->act.y_max=common->ipol(in->start.y_max,in->end.y_max,nr,anz,in->change[3]);
	in->act.y0=common->ipol(in->start.y0,in->end.y0,nr,anz,in->change[4]);
	in->act.n1=(int)common->ipol((double)in->start.n1,(double)in->end.n1,nr,anz,in->change[5]);
	in->act.n2=(int)common->ipol((double)in->start.n2,(double)in->end.n2,nr,anz,in->change[6]);
	in->act.dn=(int)common->ipol((double)in->start.dn,(double)in->end.dn,nr,anz,in->change[7]);
	in->act.time=0l;								/* zeit auf null setzen */
	in->act.pkte=0l;
	in->act.last=0;
	return &in->act;
}

static void xneu_fg(CHS_OBJC *object)
{
FEIGENBAUM *fgbm;

	fgbm=(FEIGENBAUM*)object->param->data;
	fgbm->time=0l;
	fgbm->pkte=0l;
	fgbm->last=0;
}

/*------------------------------------------------------------------------------

	anzeigeroutinen (parameter/info)

------------------------------------------------------------------------------*/
/*
		parameter anzeigen
*/
static int fg_spar(CHS_OBJC *object)
{
FEIGENBAUM *fgbm;
int ret;

	fgbm=(FEIGENBAUM*)object->param->data;

			/* schreibe parameter in dialogbox */
	strcpy((char*)common->get_obspec(fg_show_ad,FS_NAME)+8,object->name);
	common->write_double((char*)common->get_obspec(fg_show_ad,FS_RMIN),fgbm->r_min,15,11);
	common->write_double((char*)common->get_obspec(fg_show_ad,FS_RMAX),fgbm->r_max,15,11);
	common->write_double((char*)common->get_obspec(fg_show_ad,FS_XMIN),fgbm->y_min,15,11);
	common->write_double((char*)common->get_obspec(fg_show_ad,FS_XMAX),fgbm->y_max,15,11);
	common->write_double((char*)common->get_obspec(fg_show_ad,FS_X0),fgbm->y0,15,11);
	common->sprintf((char*)common->get_obspec(fg_show_ad,FS_N1),"%4d",fgbm->n1);
	common->sprintf((char*)common->get_obspec(fg_show_ad,FS_N2),"%4d",fgbm->n2);
	common->sprintf((char*)common->get_obspec(fg_show_ad,FS_DN),"%3d",fgbm->dn);

			/* zeige dialog an */
	ret=common->xdialwind(1,fg_show_ad,&fgbm_set.spar,0,0l,0l,(int*)-1l,"fg_spar")&0x7FFF;
	objc_unselect(fg_show_ad,ret);
	return 0;
}

/*
		info zurckgeben
*/
static void fg_xinfo(CHS_OBJC *object,P_INFO *info)
{
FEIGENBAUM *fgbm;
int lines;

	fgbm=(FEIGENBAUM*)object->param->data;
	info->time=fgbm->time/200.0;				/* rechenzeit */
	if ( fgbm->flag==0 ) {
		lines=object->x.bitmap.width;
		if ( fgbm->last>0 )
			lines=fgbm->last;
	}
	else {
		lines=object->x.bitmap.height;
		if ( fgbm->last>0 )
			lines-=fgbm->last;
	}
	if ( fgbm->last==0 )	/* noch nichts berechnet, lines falsch bestimmt!!! */
		lines=0;
	info->iter=(fgbm->n1+fgbm->n2)*(long)lines;	/* iterationen */
	info->points=fgbm->pkte;					/* punkte */
}

/*
		routine zum zeichnen des diagrammes
*/
static int fg_draw(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight)
{
double r,y,dr,dy;
int rr,yy,i;
FEIGENBAUM *fgbm=(FEIGENBAUM*)objc->param->data;
_draw_pkt draw;
MAKE_INFO mi;

	draw=common->init_draw(bitmap,1,0);

	mi.width=width;
	mi.height=height;
	mi.xheight=0;

	mi.pkte=fgbm->pkte;
	mi.iter=0;
	mi.time_iter=-1;
	mi.time=fgbm->time-common->gettime();

	if ( fgbm->flag==0 ) {		/* normal */
		dr=(fgbm->r_max-fgbm->r_min)/(width+1);
		dy=(height+1)/(fgbm->y_max-fgbm->y_min);

		if ( *xheight )
			{ rr=fgbm->last; mi.iter+=fgbm->last*(fgbm->n1+fgbm->n2); }
		else
			rr=0;
		mi.iter_ges=(long)(fgbm->n1+fgbm->n2)*width;
		mi.pkte_ges=(long)fgbm->n2*width;

		for ( r=fgbm->r_min+dr*rr; rr<width; rr++,r+=dr ) {
			if ( common->check_key(&mi) )
				break;

			y=fgbm->y0;
			for ( i=0; i<fgbm->n1; i++ )
				y=r*y*(1-y);
			for ( i=0; i<fgbm->n2; i++ ) {
				y=r*y*(1-y);
				if ( i%fgbm->dn==0 && y>=fgbm->y_min && y<fgbm->y_max ) {
					yy=(y-fgbm->y_min)*dy;
					draw(rr,height-yy,1);
					mi.pkte++;
				}
			}
			mi.iter+=fgbm->n1+fgbm->n2;
		}
		if ( rr==width ) {
			*xheight=-1;
			fgbm->last=-1;
		}
		else {
			*xheight=1;
			fgbm->last=rr;
		}
	}
	else {					/* quer */
		dr=(fgbm->r_max-fgbm->r_min)/(height+1);
		dy=(width+1)/(fgbm->y_max-fgbm->y_min);
		if ( *xheight )
			{ rr=fgbm->last; mi.iter+=(height-fgbm->last)*(fgbm->n1+fgbm->n2); }
		else
			rr=height-1;
		mi.iter_ges=(long)(fgbm->n1+fgbm->n2)*height;
		mi.pkte_ges=(long)fgbm->n2*height;

		for ( r=fgbm->r_min+dr*(height-rr); rr>=0; rr--,r+=dr ) {
			if ( common->check_key(&mi) )
				break;

			y=fgbm->y0;
			for ( i=0; i<fgbm->n1; i++ )
				y=r*y*(1-y);
			for ( i=0; i<fgbm->n2; i++ ) {
				y=r*y*(1-y);
				if ( i%fgbm->dn==0 && y>=fgbm->y_min && y<fgbm->y_max ) {
					yy=(y-fgbm->y_min)*dy;
					draw(yy,rr,1);
					mi.pkte++;
				}
			}
			mi.iter+=fgbm->n1+fgbm->n2;
		}
		if ( rr<0 ) {
			*xheight=-1;
			fgbm->last=-1;
		}
		else {
			*xheight=1;
			fgbm->last=rr;
		}
	}

	fgbm->time=mi.time+common->gettime();;
	fgbm->pkte=mi.pkte;

	return mi.state;
}

/*
		gib block zurck
*/
static void fg_ob_block(CHS_OBJC *object,R_REC *r)
{
FEIGENBAUM *fgbm;

	fgbm=(FEIGENBAUM*)object->param->data;
	r->phi=0.0;
	if ( fgbm->flag==0 ) {
		r->xmin=fgbm->r_min;
		r->xmax=fgbm->r_max;
		r->ymin=fgbm->y_min;
		r->ymax=fgbm->y_max;
	}
	else {
		r->xmin=fgbm->y_min;
		r->xmax=fgbm->y_max;
		r->ymin=fgbm->r_min;
		r->ymax=fgbm->r_max;
	}
}

/*
		drucke parameter
*/
static void fg_dr_par(CHS_OBJC *object,DR_INFO *di)
{
char h1[32],h2[32],h3[32];
FEIGENBAUM *fgbm;

	fgbm=(FEIGENBAUM*)object->param->data;

	common->write_double(h1,fgbm->r_min,14,8);
	common->write_double(h2,fgbm->r_max,14,8);
	common->sprintf(di->str[0],fg_dr_string1,h1,h2);

	common->write_double(h1,fgbm->y_min,14,8);
	common->write_double(h2,fgbm->y_max,14,8);
	common->write_double(h3,fgbm->y0,14,8);
	common->sprintf(di->str[1],fg_dr_string2,h1,h2,h3);

	common->sprintf(di->str[2],fg_dr_string3,fgbm->n1,fgbm->n2,fgbm->dn);

	strcpy(di->str[3],"");
	di->str[4][0]=0;
}

/*------------------------------------------------------------------------------

		initialisiere routinen

------------------------------------------------------------------------------*/
static int fg_init(int nr)
{
OBJECT *icons;
extern CHAOS_2 fgbm_2;

	fgbm_typ=nr;					/* nummer merken (fr get_objc/get_block) */

	if ( !common->rsrc_load("chs_ultd.gem\\feigenbm.rsc") ||
			!common->rsrc_gaddr(R_TREE,ICONS,&icons) ||
			!common->rsrc_gaddr(R_TREE,FG_PAR,&fg_par_ad) ||
			!common->rsrc_gaddr(R_TREE,FG_SPAR,&fg_show_ad) ) {
		return RET_INIT;
	}
	fgbm_2.icon=icons[ICON_FB].ob_spec.iconblk;

	common->dial_fix(fg_par_ad,1);
	common->dial_fix(fg_show_ad,1);

	return RET_OK;
}

static void fg_conv_set(FGBM_SET *fs,void (*conv_dpos)(DIAL_POS *dp))
{
DIAL_POS *dp;
	for ( dp=&fs->param; dp<=&fs->spar; dp++ )
		conv_dpos(dp);
}

/*------------------------------------------------------------------------------

		structuren fr schnittstelle

------------------------------------------------------------------------------*/
#pragma warn -sus

CHAOS_1 fgbm_1=
{
"TMMWFgbm",			/*	id	*/
fgbm_menue,			/*	menue	*/
"mw",fgbm_date,fgbm_text,
					/*	name, version, text	*/
(uint)sizeof(FGBM_SET), &fgbm_set,
					/*	set_len, set	*/
&fgbm_apar,
(uint)sizeof(FEIGENBAUM), (uint)sizeof(FGBM_PAR), 0, 0l, 0,
					/*	par_len, make_len, neu_len, neu_par, neu_flag	*/
0,					/* xor_lines */
_GET_OBJC|_GET_BLOCK,/* get_flag */
{64,32000,40,32000,	/*	min/max width/height */
2,2,0},				/*	min/max col, raster */
0l,					/*	kein x_mem 		*/
fg_init,			/*	do_init			*/
fg_param,			/*	get_param		*/
fg_par,				/*	get_picpar		*/
x_fg_param,			/*	set_param		*/
0l,					/*	extended		*/
fg_draw,			/*	do_draw			*/
0l,					/*	dont_draw		*/
0l,					/*	get_neu_param	*/
0l,					/*	make_neu_param	*/
xneu_fg,
fg_conv_set,
};

CHAOS_2 fgbm_2=
{
0l,					/*	icon 			*/
fgbm_menue,			/*	typ	*/
0,					/*	last_flag 		*/
1,
fg_spar,			/*	show_par		*/
0l,					/*	show_info		*/
fg_xinfo,			/*	get_info		*/
fg_ob_block,		/*	get_objcblk		*/
0,
0,
fg_dr_par,
};

static X_CHAOS xfch={X_CHAOS_ID,
		CHS_VERSION,
		1,					/* nur eine routine */
		&fgbm_1,&fgbm_2
};

