/*
	(c) 1993/1994 by TMMW Morus Walter
*/
#include "common.h"
#include "chs_ultd.gem\24nadel.h"
#include <tos.h>

static COMMON	*common;			/* zeiger fr die routinen von chaos */

int errno;				/* damit der linker nicht motzt;
							sonst in pc_start deklariert */

CHS_PRN *ret_prn(COMMON *com)
{
extern CHS_PRN chs_prn;

	common=com;				/* merke com */
	return &chs_prn;				/* gib eigene routinen zurck */
}

typedef struct {
	int			width;
	char 		code[8][10];
	char		hc_spalten;
	char		hc_size;		/* 1,2,3,4 mal */
	char		hc_format;		/* 0 normal, 1 quer */
	char		hc_leer;		/* leerzeilen drucken (1) / nicht drucken (0) */
	char		hc_abstand;		/* 0,1,2 abstand klein, mittel, gro,
								   3 parameter drucken */
	char		hc_ff;			/* FormFeed nach hc_ff bildern (0 kein FF) */
	KONV_INFO	ki;
	DIAL_POS	drpar;
	DIAL_POS	hcopy;
} DR_INST;

DR_INST set={
	8*180,
	{{0x1B,0x2a,0x27,0xFF},
	{0x0D,0x0A,0xFF},
	{0x1B,0x33,0xFF},
	{0x1B,0x33,0x18,0xFF},
	{0x0D,0x0A,0xFF},
	{0x0C,0xFF},
	{0x1B,0x4F,0xFF},
	{0x1B,0x24,0xFF} },
	2,
	1,
	0,
	0,
	1,
	0,
	{0,2,NICHT_KONVERTIERT,_RGB,ABSOLUT,255,2,12,0},
	{0,0},
	{0,0},
};

MFORM print_mouse={
0x0009,0x0008,0x0001,0x0000,0x0001,
0x0000,0x03F8,0x07FC,0x0FF8,
0x0FFC,0x1FFE,0x3FFF,0x7FFF,
0xFFFF,0xFFFF,0xFFFF,0xFFFE,
0xFFFC,0xFFF8,0x3FC0,0x0000,
0x0000,0x0000,0x03F8,0x0410,
0x0410,0x083C,0x1826,0x2FEA,
0x4012,0x3FCA,0x4024,0x5C28,
0x4030,0x3FC0,0x0000,0x0000};

#define GRAPH		0
#define _CR			1
#define ABSTGR 		2
#define ABSTTXT		3
#define _LF			4
#define _FF			5
#define INIT		6
#define DR_POS		7

OBJECT *hcopy_ad,*drpar_ad;

static int init_hcopy(void)
{
	if ( !common->rsrc_load("chs_ultd.gem\\24nadel.rsc") ||
			!common->rsrc_gaddr(R_TREE,HRDCPY24,&hcopy_ad) ||
			!common->rsrc_gaddr(R_TREE,PRINTER,&drpar_ad) ) {
		return RET_INIT;
	}
	common->dial_fix(hcopy_ad,1);
	common->dial_fix(drpar_ad,1);
	return RET_OK;
}

static void conv_param(DR_INST *inst,void (*conv_dpos)(DIAL_POS *dp))
{
	conv_dpos(&inst->drpar);
	conv_dpos(&inst->hcopy);
}

/*------------------------------------------------------------------------------

	drucke hardcopy

------------------------------------------------------------------------------*/
	/*
			drucker code ausgeben
	*/
static void d_code_out(int nr)
{
int i;
	i=0;
	while (i<10 && set.code[nr][i]!=255)
		common->pr_byte(set.code[nr][i++]);
}

	/*
		gepufferte ausgabe (um leere zeilen zu testen)
	*/
X_DATA_P pr_puf=0l;
static char *prnout_ptr=0l;
static void init_prnout(int width,int anz)
{
	common->x_malloc((width+1)*anz*3l,&pr_puf);
}
static void exit_prnout(void)
{
	common->x_mfree(&pr_puf);
}
	/* ACHTUNG!!!!
		zwischen reset_prnout, den prnout-aufrufen und do_prnout:
				keine SPEICHERVERWALTUNGSAUFRUFE!!
	*/
static int reset_prnout(void)
{
	if ( pr_puf ) {
		prnout_ptr=(char*)pr_puf->data;
		return 1;
	}
	else {
		prnout_ptr=0l;
		return 0;
	}
}
static void prnout(char c)
{
	if ( prnout_ptr )
		*prnout_ptr++=c;
	else
		common->pr_byte(c);
}
static void do_prnout(int low,int high)
{
char *h;
long len;

	if ( prnout_ptr ) {
		while ( !prnout_ptr[-1] && !prnout_ptr[-2] && !prnout_ptr[-3] ) {
			prnout_ptr-=3;
			if ( low==0 )
				{ high--; low=255; }
			else
				low--;
		}
		d_code_out(GRAPH);
		common->pr_byte(low);
		common->pr_byte(high);
		h=(char*)pr_puf->data;
		len=prnout_ptr-h;
		common->pr_bytes(h,len);
	}
}

	/*
		hilfs-routinen (fr zeilenweises ausdrucken)
	*/
typedef struct		/* fr hardcopy */
{
	int zeilen;		/* auszudruckende zeilen */
	int spalten;	/* auszudruckende spalten (u.U. kleiner bildbreite) */
	int bytes_lo;
	int bytes_hi;
	int pos_lo;
	int pos_hi;
	int col_flag;
} HC_PARAM;

typedef struct
{
	int linien;		/* auf einmal (mit 24 Nadeln) auszudruckende zeilen */
	int anz;		/* wiederholungen */
	long bit[24];
	int flags[24];
	unsigned int *zeiger[24];
} HC_XPARAM;		/* spalten-bergreifend */

static void set_hcxparam(HC_XPARAM *xhc)
{
int i;

	if ( set.hc_size==1 ) {
		xhc->linien=24;
		for ( i=0; i<24; i++ )
			xhc->bit[i]=1L<<(23-i);
		xhc->anz=1;
	}
	else if ( set.hc_size==2 ) {
		xhc->linien=12;
		for ( i=0; i<12; i++ )
			xhc->bit[i]=3L<<(22-i*2);
		xhc->anz=2;
	}
	else if( set.hc_size==3 ) {
		xhc->linien=8;
		for ( i=0; i<8; i++ )
			xhc->bit[i]=7L<<(21-i*3);
		xhc->anz=3;
	}
	else /* if( set.hc_size==4 ) */ {
		xhc->linien=6;
		for ( i=0; i<6; i++ )
			xhc->bit[i]=15L<<(20-i*4);
		xhc->anz=4;
	}
}

static void set_hcparam(HC_PARAM *hc,MFDB *mfdb,HC_XPARAM *xhc,int col_flag,int nr)
{
long width,max_width;

	max_width=set.width/set.hc_spalten;

	hc->col_flag=col_flag;
	if ( set.hc_format==0 ) {
		hc->spalten=mfdb->fd_wdwidth;
		hc->zeilen=mfdb->fd_h;

		width=hc->spalten*xhc->anz*16l;
		if ( width>max_width )
			hc->spalten=(int)(max_width/16l/xhc->anz);
		width=hc->spalten*xhc->anz*16l;
	}
	else {
		hc->spalten=mfdb->fd_h;
		hc->zeilen=mfdb->fd_w;
		width=hc->spalten*xhc->anz;
		if ( width>max_width )
			hc->spalten=(int)(max_width/xhc->anz);
		width=(long)hc->spalten*xhc->anz;
	}

	hc->bytes_lo=(int)width&255;
	hc->bytes_hi=(int)width/256;

	max_width/=3;
	width/=3;
	width=(max_width-width)/2;
	if ( !set.hc_format )
		width+=nr*max_width;
	else
		width+=(set.hc_spalten-nr-1)*max_width;
	hc->pos_lo=(int)width&255;
	hc->pos_hi=(int)width/256;
}

/*------------------------------------------------------------------------------
	hardcopy normal
------------------------------------------------------------------------------*/
static int prt_line(HC_XPARAM *xhc,HC_PARAM *hc)
{							/* return 1 -> zeile gedruckt, 0 -> zeile leer */
int prn_flag;
int i,x,xx;
long bits;
char *out;
int lineflag;
unsigned int maske;

	prn_flag=reset_prnout();

	d_code_out(DR_POS);		/* zentrieren */
	common->pr_byte(hc->pos_lo);
	common->pr_byte(hc->pos_hi);

	if ( !prn_flag ) {
		d_code_out(GRAPH);
		common->pr_byte(hc->bytes_lo);
		common->pr_byte(hc->bytes_hi);
	}

	lineflag=0;

	for ( x=0; x<hc->spalten; x++ ) {

		maske=0x8000;
		for ( xx=0; xx<16; xx++ ) {
			bits=0;
			for ( i=0; i<xhc->linien; i++ ) {
				if ( (*(xhc->zeiger[i]))&maske )
					bits|=xhc->bit[i];
			}
			if ( hc->col_flag )
				bits=~bits;
			if ( bits )
				lineflag=1;

			for ( i=0; i<xhc->anz; i++ ) {
				out=(char*)&bits;
				out++;
				prnout(*out);
				out++;
				prnout(*out);
				out++;
				prnout(*out);
			}
			maske>>=1;
		}
		for ( i=0; i<xhc->linien; i++ ) {
			if ( xhc->flags[i] ) {
				xhc->zeiger[i]++;
			}
		}
	}
	if ( prn_flag && lineflag ) {
		do_prnout(hc->bytes_lo,hc->bytes_hi);
	}

	return lineflag;
}

static int do_hardcopy(MFDB *mfdb,X_DATA_P *mem,int *col_flag,int anz)
{
HC_XPARAM xhc;
HC_PARAM hc[8];
int max_spalten,max_zeilen,pic;
int zeile,i,j;
unsigned int leer=0;
int cr_flag;
int abst,max_abst;

	set_hcxparam(&xhc);
	for ( pic=0; pic<anz; pic++ )
		set_hcparam(&hc[pic],&mfdb[pic],&xhc,col_flag[pic],pic);

	max_spalten=0;
	max_zeilen=0;
	for ( pic=0; pic<anz; pic++ ) {
		if ( hc[pic].spalten>max_spalten )
			max_spalten=hc[pic].spalten;
		if ( hc[pic].zeilen>max_zeilen )
			max_zeilen=hc[pic].zeilen;
	}

	init_prnout(max_spalten*16,xhc.anz);

	d_code_out(ABSTGR);
	common->pr_byte(24);

	for ( zeile=0; zeile<max_zeilen; zeile+=xhc.linien ) {
		cr_flag=0;
		max_abst=0;
		for ( pic=0; pic<anz; pic++ ) {
			abst=0;
			for ( i=zeile,j=0; j<xhc.linien; i++,j++ ) {
				if ( i<hc[pic].zeilen ) {
					xhc.zeiger[j]=(unsigned int*)(mem[pic]->data)+(long)i*mfdb[pic].fd_wdwidth;
					xhc.flags[j]=1;
					abst++;
				}
				else {
					xhc.zeiger[j]=&leer;
					if ( hc[pic].col_flag )
						leer=0xFFFF;
					else
						leer=0x0;
					xhc.flags[j]=0;
				}
			}
			if ( abst>max_abst )
				max_abst=abst;

			if ( prt_line(&xhc,&hc[pic]) || set.hc_leer )
				cr_flag=1;
		}
		if ( max_abst*xhc.anz!=24 ) {
			d_code_out(ABSTGR);
			common->pr_byte(max_abst*xhc.anz);
		}
		if ( cr_flag )
			d_code_out(_CR);

		if ( common->check_key(0l) ) {
			exit_prnout();
			return 1;
		}
	}

	exit_prnout();
	return 0;
}

/*------------------------------------------------------------------------------
	hardcopy quer
------------------------------------------------------------------------------*/
static int prt_quer_line(HC_XPARAM *xhc,HC_PARAM *hc,char *maske,int xoff)
{							/* return 1 -> zeile gedruckt, 0 -> zeile leer */
int prn_flag;
int i,x;
long bits;
char *out;
int lineflag;

	prn_flag=reset_prnout();

	d_code_out(DR_POS);		/* zentrieren */
	common->pr_byte(hc->pos_lo);
	common->pr_byte(hc->pos_hi);

	if ( !prn_flag ) {
		d_code_out(GRAPH);
		common->pr_byte(hc->bytes_lo);
		common->pr_byte(hc->bytes_hi);
	}

	lineflag=0;

	for ( x=0; x<hc->spalten; x++ ) {
		bits=0;
		for ( i=0; i<xhc->linien; i++ ) {
			if ( (*(char*)xhc->zeiger[i])&maske[i] )
				bits|=xhc->bit[i];
		}
		if ( hc->col_flag )
			bits=~bits;
		if ( bits )
			lineflag=1;

		for ( i=0; i<xhc->anz; i++ ) {
			out=(char*)&bits;
			out++;
			prnout(*out);
			out++;
			prnout(*out);
			out++;
			prnout(*out);
		}

		for ( i=0; i<xhc->linien; i++ ) {
			if ( xhc->flags[i] )
				xhc->zeiger[i]-=xoff;
		}
	}

	if ( prn_flag && lineflag ) {
		do_prnout(hc->bytes_lo,hc->bytes_hi);
	}

	return lineflag;
}

static int do_hc_quer(MFDB *mfdb,X_DATA_P *mem,int *col_flag,int anz)
{
int pic;
HC_XPARAM xhc;
HC_PARAM hc[8];
long offset[8];
char maske[24];
int max_spalten,max_zeilen;
int zeile,i,j;
int cr_flag;
unsigned int leer=0;
int abst,max_abst;

	set_hcxparam(&xhc);
	for ( pic=0; pic<anz; pic++ ) {
		set_hcparam(&hc[pic],&mfdb[pic],&xhc,col_flag[pic],pic);
		offset[pic]=(long)(hc[pic].spalten-1)*(long)mfdb[pic].fd_wdwidth*2l;
	}

	max_spalten=0;
	max_zeilen=0;
	for ( pic=0; pic<anz; pic++ ) {
		if ( hc[pic].spalten>max_spalten )
			max_spalten=hc[pic].spalten;
		if ( hc[pic].zeilen>max_zeilen )
			max_zeilen=hc[pic].zeilen;
	}

	init_prnout(max_spalten,xhc.anz);

	d_code_out(ABSTGR);
	common->pr_byte(24);

	for ( zeile=0; zeile<max_zeilen; zeile+=xhc.linien ) {
		cr_flag=0;
		max_abst=0;
		for ( pic=0; pic<anz; pic++ ) {
			abst=0;
			for ( i=zeile,j=0; j<xhc.linien; i++,j++ ) {
				if ( i<hc[pic].zeilen ) {
					xhc.zeiger[j]=(unsigned int*)((char*)mem[pic]->data+offset[pic]+i/8);
					xhc.flags[j]=1;
					abst++;
				}
				else {
					xhc.zeiger[j]=&leer;
					if ( hc[pic].col_flag )
						leer=0xFFFF;
					else
						leer=0x0;
					xhc.flags[j]=0;
				}
				maske[j]=0x80>>(i&7);
			}
			if ( abst>max_abst )
				max_abst=abst;

			if ( prt_quer_line(&xhc,&hc[pic],maske,mfdb[pic].fd_wdwidth) || set.hc_leer )
				cr_flag=1;
		}

		if ( max_abst*xhc.anz!=24 ) {
			d_code_out(ABSTGR);
			common->pr_byte(max_abst*xhc.anz);
		}
		if ( cr_flag )
			d_code_out(_CR);

		if ( common->check_key(0l) ) {
			exit_prnout();
			return 1;
		}
	}

	exit_prnout();
	return 0;
}

static int do_exec_hardcopy(CHS_OBJC *obs[],int anz)
{
X_DATA_P mem[8];
X_DATA_P c_tab;
MFDB mfdb[8];
int col_flag[8];
int h;
int i;
COLOR *col;

	for ( i=0; i<anz; i++ ) {
		/* bild holen */
		h=common->get_hcopy_planes(&set.ki,obs[i],&mfdb[i],&mem[i],&c_tab,1);
		if ( h==RET_SIZE ) {
			common->exit_xinfo();
			common->maus_unbusy(0);
			common->do_error(ERR_SCALE,0,1);
			common->maus_busy(&print_mouse);
			h=common->get_hcopy_planes(0l,obs[i],&mfdb[i],&mem[i],&c_tab,1);
		}

		if ( h!=RET_OK ) {
			for ( ; i>0; )
				common->x_mfree(&mem[--i]); 
			common->x_mfree(&c_tab);
			return RET_ERROR;
		}
		if ( c_tab )
			col=(COLOR*)c_tab->data;
		else
			col=(COLOR*)obs[i]->x.bitmap.col_tab->data;
		if ( col->blue>0 )
			col_flag[i]=0;
		else
			col_flag[i]=1;
		common->x_mfree(&c_tab);		
	}

	if ( anz==1 )
		common->init_xinfo(" Drucke ",obs[0]->name,1);
	else
		common->init_xinfo(" Drucke "," ...",1);

	if ( set.hc_format==0 )
		h=do_hardcopy(mfdb,mem,col_flag,anz);
	else
		h=do_hc_quer(mfdb,mem,col_flag,anz);

	for ( i=0; i<anz; i++ )
		common->x_mfree(&mem[i]);

	return h;
}

static void pr_info(CHS_OBJC *ob)
{
int i;
DR_INFO di;

	if ( common->get_dr_info(ob,&di)==RET_OK ) {
		for ( i=0; i<5; i++ )
			if ( di.str[i][0]!=0 ) {
				common->pr_bytes(di.str[i],strlen(di.str[i]));
				d_code_out(_LF);
			}
	}
	else
		d_code_out(_LF);
}

int exec_hardcopy(CHS_OBJC *obs[],int anz)
{
int ret;

	ret=do_exec_hardcopy(obs,anz);

	if ( !ret ) {
		if ( set.hc_abstand==0 ) {
			d_code_out(ABSTGR);
			common->pr_byte(12);
			d_code_out(_CR);
		}
		else if ( set.hc_abstand==1 ) {
			d_code_out(ABSTTXT);
			d_code_out(_LF);
		}
		else if ( set.hc_abstand==3 && anz==1 ) {
			d_code_out(ABSTGR);
			common->pr_byte(12);
			d_code_out(_CR);
			d_code_out(ABSTTXT);
			pr_info(obs[0]);
		}
		else /* set.hc_abstand==2 || set.hc_abstand==3 && anz!=1 */ {
			d_code_out(ABSTTXT);
			d_code_out(_LF);
			d_code_out(_LF);
		}
	}

	return ret;
}

/*------------------------------------------------------------------------------

		hardcopy managen, parameter eingeben, ...

------------------------------------------------------------------------------*/
int hc_button(int object,void *data,void *dw)
{
int ok;

	object&=0x7FFF;

	objc_unselect(hcopy_ad,object);
	if ( object==HC_SCNV ) {
		ok=1;
		common->get_konv_info((KONV_INFO*)data,""," Hardcopy-Konversion einstellen ",&ok);
		common->make_konv_str((KONV_INFO*)data,2,(char*)common->get_obspec(hcopy_ad,HC_SCALE),(char*)common->get_obspec(hcopy_ad,HC_KONV));
		if ( ok )
			return HC__KONV;
		else
			return -1;			/* redraw all */
	}
	if ( object==HC_LF ) {
		d_code_out(_LF);
		return HC_LF;
	}
	else if ( object==HC_FF) {
		d_code_out(_FF);
		return HC_FF;
	}
	else if ( object==HC_INIT) {
		d_code_out(INIT);
		return HC_INIT;
	}
	return 0;
}

void hardcopy(int ks,int dm,void *pw,int objc)
{
int ret,anz,hc_anz,abbr;
KONV_INFO ki;
CHS_OBJC *ob,*obs[8];
int exec_hardcopy(CHS_OBJC *ob[],int anz);
char str1[64],str2[64];

	if ( common->check_printer()!=RET_OK )
		return;

	hc_anz=0;
	ob=common->first_ob(GET_PICS,ks,dm,pw,objc);
	while ( ob ) {
		hc_anz++;
		ob=common->next_ob();
	}
	common->sprintf((char*)common->get_obspec(hcopy_ad,HC_ANZ),"%4d",hc_anz);

	objc_unselect(hcopy_ad,HC_S1);
	objc_unselect(hcopy_ad,HC_S2);
	objc_unselect(hcopy_ad,HC_S3);
	objc_unselect(hcopy_ad,HC_S4);
	objc_unselect(hcopy_ad,HC_S5);
	objc_unselect(hcopy_ad,HC_S6);
	objc_unselect(hcopy_ad,HC_S7);
	objc_unselect(hcopy_ad,HC_S8);
	objc_select(hcopy_ad,HC_S1-1+set.hc_spalten);

	objc_unselect(hcopy_ad,HC_1);
	objc_unselect(hcopy_ad,HC_2);
	objc_unselect(hcopy_ad,HC_3);
	objc_unselect(hcopy_ad,HC_4);
	objc_select(hcopy_ad,HC_1-1+set.hc_size);

	objc_unselect(hcopy_ad,HC_NORM);
	objc_unselect(hcopy_ad,HC_QUER);
	if ( !set.hc_format )
		objc_select(hcopy_ad,HC_NORM);
	else
		objc_select(hcopy_ad,HC_QUER);

	objc_unselect(hcopy_ad,HC_SP);
	objc_unselect(hcopy_ad,HC_NOSP);
	if ( !set.hc_leer )
		objc_select(hcopy_ad,HC_NOSP);
	else
		objc_select(hcopy_ad,HC_SP);

	objc_unselect(hcopy_ad,HC_AB1);
	objc_unselect(hcopy_ad,HC_AB2);
	objc_unselect(hcopy_ad,HC_AB3);
	objc_unselect(hcopy_ad,HC_ABPAR);
	objc_select(hcopy_ad,HC_AB1+set.hc_abstand);

	common->sprintf(objc_tedstr(hcopy_ad,HC_FFANZ),"%2d",set.hc_ff);

	ki=set.ki;
	common->make_konv_str(&ki,2,str1,str2);
	common->set_obspec(hcopy_ad,HC_SCALE,(long)str1);
	common->set_obspec(hcopy_ad,HC_KONV,(long)str2);

	d_code_out(ABSTTXT);

	ret=common->xdialwind(1,hcopy_ad,&set.hcopy,HC_FFANZ,hc_button,&ki,(int*)-1l,"hcopy24")&0x7FFF;

	if ( ret==HC_ABBR )
		return;

	if ( objc_selected(hcopy_ad,HC_S1) )				set.hc_spalten=1;
	else if ( objc_selected(hcopy_ad,HC_S2) )			set.hc_spalten=2;
	else if ( objc_selected(hcopy_ad,HC_S3) )			set.hc_spalten=3;
	else if ( objc_selected(hcopy_ad,HC_S4) )			set.hc_spalten=4;
	else if ( objc_selected(hcopy_ad,HC_S5) )			set.hc_spalten=5;
	else if ( objc_selected(hcopy_ad,HC_S6) )			set.hc_spalten=6;
	else if ( objc_selected(hcopy_ad,HC_S7) )			set.hc_spalten=7;
	else /* if ( objc_selected(hcopy_ad,HC_S8) ) */		set.hc_spalten=8;

	if ( objc_selected(hcopy_ad,HC_1) ) 				set.hc_size=1;
	else if ( objc_selected(hcopy_ad,HC_2) ) 			set.hc_size=2;
	else if ( objc_selected(hcopy_ad,HC_3) ) 			set.hc_size=3;
	else /* if ( objc_selected(hcopy_ad,HC_4) ) */ 		set.hc_size=4;

	if ( objc_selected(hcopy_ad,HC_NORM) )				set.hc_format=0;
	else /* if ( objc_selected(hcopy_ad,HC_QUER) ) */	set.hc_format=1;

	if ( objc_selected(hcopy_ad,HC_SP) )				set.hc_leer=1;
	else /* if ( objc_selected(hcopy_ad,HC_NOSP) ) */	set.hc_leer=0;

	if ( objc_selected(hcopy_ad,HC_AB1) )				set.hc_abstand=0;
	else if ( objc_selected(hcopy_ad,HC_AB2) )			set.hc_abstand=1;
	else if ( objc_selected(hcopy_ad,HC_AB3) )			set.hc_abstand=2;
	else /* if ( objc_selected(hcopy_ad,HC_ABPAR) ) */	set.hc_abstand=3;

	set.ki=ki;

	common->sscanf(objc_tedstr(hcopy_ad,HC_FFANZ),"%d",&hc_anz);
	set.hc_ff=hc_anz;
	if ( ret==HC_EINST )
		return;

	common->maus_busy(&print_mouse);
	ob=common->first_ob(GET_PICS,ks,dm,pw,objc);
	hc_anz=0;
	anz=0;
	abbr=0;
	while ( ob ) {
		obs[anz++]=ob;
		if ( anz==set.hc_spalten ) {
			abbr=exec_hardcopy(obs,anz);
			anz=0;
			hc_anz++;
			if ( set.hc_ff!=0 && hc_anz==set.hc_ff ) {
				d_code_out(_FF);
				hc_anz=0;
			}
			if ( abbr || common->check_key(0l) )
				break;
		}
		ob=common->next_ob();
	}
	if ( anz ) {
		abbr=exec_hardcopy(obs,anz);
		hc_anz++;
		if ( set.hc_ff!=0 && hc_anz==set.hc_ff ) {
			d_code_out(_FF);
			hc_anz=0;
		}
	}
	common->maus_unbusy(0);
	common->exit_xinfo();
	d_code_out(INIT);
}

/*------------------------------------------------------------------------------

		druckeranpassung

------------------------------------------------------------------------------*/
static int hex_zif(char z)
{
	if (z>='0' && z<='9')		return z-'0';
	else if (z>='A' && z<='F')	return z-'A'+10;
	else if (z>='a' && z<='f')	return z-'a'+10;
	/*else if (z=='x' || z=='X')	return 0; /* redundant*/*/
	else 						return 0;
}
static char hex(char *addr)
{
	return(hex_zif(*addr)*16+hex_zif(*(addr+1)));
}

void dr_param(void)
{
int i,h,ret;
char *hexerw="FFFFFFFFFFFFFFFFFFFF";
static int codes[8]={H_GRAPH,H_CR,H_ABST1,H_ABST2,H_LF,H_FF,H_INIT,H_POS};

	common->sprintf(objc_tedstr(drpar_ad,H_WIDTH),"%5d",set.width);
	for ( i=0; i<=DR_POS; i++ ) {
		for( h=0; h<10 && set.code[i][h]!=0xFF; h++ ) {
			common->sprintf(objc_tedstr(drpar_ad,codes[i])+2*h,"%02X",set.code[i][h]);
		}
	}

	ret=common->xdialwind(1,drpar_ad,&set.drpar,H_WIDTH,0l,0l,(int*)-1l,"drpar24")&0x7FFF;
	objc_unselect(drpar_ad,ret);

	if ( ret==H_OK ) {
	  char string[50];
		common->sscanf(objc_tedstr(drpar_ad,H_WIDTH),"%5d",&set.width);
		for ( i=0; i<=DR_POS; i++ ) {
			strcpy(string,objc_tedstr(drpar_ad,codes[i]));
			strcat(string,hexerw);
			for( h=0; h<10; h++ ) {
				set.code[i][h]=hex(string+2*h);
			}
		}
	}
}

#pragma warn -sus

CHS_PRN chs_prn={
	X_CHAOS_ID,
	CHS_VERSION,
	'HCPY',
	"TMMWhcpy",
	"24 Nadeldrucker Hardcopy",
	"Th. Morus Walter",
	"V1.0 10.10.1993",			
	init_hcopy,
	hardcopy,
	dr_param,
	conv_param,

	(uint)sizeof(DR_INST),
	&set,
};
