/*
	(c) 1993/1994 by TMMW Morus Walter
*/
#include "xchs.h"

int draw_popcorn(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight);

extern COMMON *xcommon;

typedef struct {
	double xmin;
	double xmax;
	double ymin;
	double ymax;

	double h;

	int steps;
	int abst;

	char speed;

	long time;
	long iter;
	long pkte;
} POPCORN;

typedef struct {
	int x;
	int y;
} XPOP;

typedef struct {
	POPCORN start;
	POPCORN ende;
	char change[7];
} P_SET;

static RSIB0DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0xBC08, 0x84B0, 0x0001, 0xB222, 
  0x9940, 0x0001, 0xEC36, 0x3A80, 
  0x0005, 0xA00F, 0xB900, 0x0007, 
  0x86B1, 0xB820, 0x000F, 0x188D, 
  0x64C0, 0x001C, 0x4424, 0xAF48, 
  0x0034, 0xA4A4, 0xA908, 0x0023, 
  0x9020, 0x85C8, 0x00E0, 0x0004, 
  0x2F40, 0x008A, 0x8291, 0x2922, 
  0x0182, 0x0804, 0x4578, 0x0228, 
  0x2551, 0x044A, 0x0628, 0x8804, 
  0x535E, 0x0560, 0x2001, 0x0152, 
  0x0C51, 0x4000, 0x54D6, 0x0A00, 
  0x02E0, 0x0016, 0x18C2, 0x8418, 
  0x28C6, 0x1021, 0x0804, 0x0228, 
  0x1540, 0x10E2, 0x1446, 0x2121, 
  0x1032, 0x213E, 0x6401, 0x1010, 
  0x1028, 0x0000, 0x0000, 0x0000
};

static ICONBLK rs_iconblk =
{ 0l, RSIB0DATA, "XXXXXXXX", 0x1000|'\0',
    1,   1,   0,   0,  48,  24,   0,  23,  48,   8,
};

static P_SET p_set=
{
	{-2.0,2.0,-1.5,1.5,0.01,150,1},
	{-2.0,2.0,-1.5,1.5,0.01,150,1},
	{1,1,1,1,1,1,1}
};

static ALLG_PAR	p_apar={1,"POPCORN",640,400,1,0,2};

XCHAOS popcorn={
	/* def */
{	1,	/* koords */
	{	{P_DOUBLE,	"h        :"},
		{P_INTEGER,	"Schritte :"},
		{P_INTEGER,	"Abstand  :"},
		{P_EMPTY,	0l},
		{P_EMPTY,	0l},
		{P_EMPTY,	0l}		},
	{	{F_RBUTTON,	"Modus",	2,	"exakt","schnell",0l,0l,0l},
		{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l},
		{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l},
		{F_EMPTY,	0l,			0,	0l,0l,0l,0l,0l}		},
	0,0l,
	"xp_param",	"xp_neu",	"xp_spar",
},
	/* chaos_1 (unvollstndig) */
{
	"TMMWpcrN",					/* id */
	"Popcorn",					/* menue */
	"mw","V1.1, 15.12.1993",
	"",	/*	name, version, text	*/

	(uint)sizeof(P_SET),&p_set,		/* set_len/set */
	&p_apar,
	0,0,0,0l,0,				/* par_len, make_len, neu_len, trgt X_CHAOS ein */
	0,							/* xor_lines */
	0,	/* trgt X_CHAOS ein */
	{64,32000,40,32000,			/* min/max width/height */
	2,256,1},					/* min/max col, raster */
	0l,							/* x_mem, unused */

	0l,0l,0l,0l,0l,
	draw_popcorn
	/* ... -> 0l */				/* trgt X_CHAOS ein */
},
	/* chaos_2 (unvollstndig) */
{
	&rs_iconblk,
	"Popcorn",
	0,							/* last-flag */
	/* ... */					/* trgt X_CHAOS ein */
},
};
XCHAOS *popc=&popcorn;

int draw_popcorn(CHS_OBJC *objc,int width,int height,int colors,BITMAP *bitmap,int *xheight)
{
POPCORN *param=(POPCORN*)objc->param->data;
_draw_pkt draw;
int x_,y_,xc,yc;
double dx,dy,idx,idy;
int n,col;
MAKE_INFO mi;
XPOP *xp;

	col=colors-1;
	mi.width=width;
	mi.height=height;
	mi.xheight=-1;
	mi.pkte=param->pkte;
	mi.iter=param->iter;
	mi.iter_ges=(long)(width/param->abst)*(long)(height/param->abst)*param->steps;
	mi.time_iter=130;
	mi.pkte_ges=mi.iter_ges;
	mi.time=param->time-xcommon->gettime();

	draw=xcommon->init_draw(bitmap,1,-1);
	dx=(param->xmax-param->xmin)/width;
	dy=(param->ymax-param->ymin)/height;
	idx=1.0/dx;
	idy=1.0/dy;
	if ( objc->x_param!=0 ) {
		xp=(XPOP*)objc->x_param->data;
		x_=xp->x;
		y_=xp->y;
		xcommon->x_mfree(&objc->x_param);
	}
	else {
		x_=0;
		y_=0;
	}

	*xheight=height;

	if ( !param->speed ) {
	  double x,xx,y;
		for ( ; y_<height; y_+=param->abst ) {
			for ( ; x_<width; x_+=param->abst ) {
				x=param->xmin+x_*dx;
				y=param->ymax-y_*dy;
				for ( n=0; n<param->steps; n++ ) {
					xx=x-param->h*sin(y+tan(3.0*y));
					y-=param->h*sin(x+tan(3.0*x));
					x=xx;
					xc=(x-param->xmin)*idx;
					yc=(param->ymax-y)*idy;
					mi.iter++;
					if ( xc>=0 && yc>=0 && xc<width && yc<height ) {
							draw(xc,yc,(int)(mi.iter%col)+1);
						mi.pkte++;
					}
				}
				if ( xcommon->check_key(&mi) ) {
					param->time=mi.time+xcommon->gettime();
					param->iter=mi.iter;
					param->pkte=mi.pkte;
	
					xcommon->x_malloc(sizeof(XPOP),&objc->x_param);
					xp=(XPOP*)objc->x_param->data;
					xp->x=x_;
					xp->y=y_;
					return mi.state;
				}
			}
			x_=0;
		}
	}
	else {	/* quick */
	  long xmin,ymax,ldx,ldy,lidx,lidy,x,y,h;
	  long phi,s,c,t,xx;

		xmin=param->xmin*(1l<<16);
		ymax=param->ymax*(1l<<16);
		ldx=dx*(1l<<16);
		ldy=dy*(1l<<16);
		lidx=idx*(1l<<16);
		lidy=idy*(1l<<16);
		h=param->h*(1l<<16);

		for ( ; y_<height; y_+=param->abst ) {
			for ( ; x_<width; x_+=param->abst ) {
				x=xmin+ldx*x_;		/* mult fixkomma,integer! */
				y=ymax-ldy*y_;
				for ( n=0; n<param->steps; n++ ) {

					phi=y+y+y;
					xcommon->sincos68(phi,&s,&c);
					t=xcommon->divide(s,c,16);
					t+=y;
					xcommon->sincos68(t,&s,&c);
					xx=x-xcommon->multiply(s,h,16);

					phi=x+x+x;
					xcommon->sincos68(phi,&s,&c);
					t=xcommon->divide(s,c,16);
					t+=x;
					xcommon->sincos68(t,&s,&c);
					y-=xcommon->multiply(s,h,16);
					x=xx;

					xc=(int)(xcommon->multiply((x-xmin),lidx,16)>>16);
					yc=(int)(xcommon->multiply((ymax-y),lidy,16)>>16);
					mi.iter++;
					if ( xc>=0 && yc>=0 && xc<width && yc<height ) {
							draw(xc,yc,(int)(mi.iter%col)+1);
						mi.pkte++;
					}
				}
				if ( xcommon->check_key(&mi) ) {
					param->time=mi.time+xcommon->gettime();
					param->iter=mi.iter;
					param->pkte=mi.pkte;
	
					xcommon->x_malloc(sizeof(XPOP),&objc->x_param);
					xp=(XPOP*)objc->x_param->data;
					xp->x=x_;
					xp->y=y_;
					return mi.state;
				}
			}
			x_=0;
		}
	}

	param->time=mi.time+xcommon->gettime();
	param->iter=mi.iter;
	param->pkte=mi.pkte;

	*xheight=-1;
	return mi.state;
}
