/*
	(c) 1993/1994 by TMMW Morus Walter
*/
#include <math.h>
#include "..\common.h"

typedef enum 
{
	P_EMPTY=0,
	P_INTEGER,
	P_LONG,
	P_DOUBLE
} VAR_TYPE;

typedef struct {
	VAR_TYPE type;
	char *text;
} XCHAOS_VAR;

typedef enum 
{
	F_EMPTY=0,
	F_BUTTON,
	F_RBUTTON,
} FLAG_TYPE;

typedef struct {
	FLAG_TYPE type;
	char *text;
	int anz;
	char *texte[5];
} XCHAOS_FLAG;

typedef struct {		/* voreinstellungen fr popupmen in parametereingabe */
	char *name;
	void *set;
} DEF_SET;

typedef struct {
	int			koords;		/* 0 keine, 1 min/max, 2 scale/off, 3 both */

	XCHAOS_VAR	par[6];		/* parameter */
	XCHAOS_FLAG flag[4];	/* flags */

	int			def_set;	/* zahl mglicher voreinstellungen */
	DEF_SET		*sets;		/* zeiger auf voreinstellungen */

	char		*x_param;	/* hilfs-datei fr parametereingabe */
	char		*x_neu;		/* hilfs-datei fr neu */
	char		*x_spar;	/* hilfs-datei fr zeige parameter */
} XCHAOS_DEF;

/*------------------------------------------------------------------------------

		interne strukturen zur verwaltung der parameter

------------------------------------------------------------------------------*/
/*
	parameter werden folgendermaen verwaltet:

	koords: 4 double
	par:	je nach flag (0 Byte, integer (2 Byte), long (4 Byte), double (10 Byte)
	flag:	falls vorhanden: (u)char
*/

typedef struct {
	char xmin;
	char xmax;
	char ymin;
	char ymax;
	char par[6];
	char flag[4];

	int ende;
	int change;
	int pic;
	int time;
	int len;
} PAR_OFFS;

typedef struct {
	double *xmin;
	double *xmax;
	double *ymin;
	double *ymax;
	void *par[6];
	char *flag[4];
} PAR_PTR;

typedef struct {
	PAR_PTR start;
	PAR_PTR ende;
	char *change;
	PAR_PTR pic;
	long *time;
	long *iter;
	long *pkte;		/* nur falls nicht last_flag */
} MPAR_PTR;

typedef struct {
	void *par[6];
	char *flag[4];
	char *p_ch[6];
	char *f_ch[4];
} MCH_PTR;

/*------------------------------------------------------------------------------

		bergabestruktur an xchaos.c

------------------------------------------------------------------------------*/

typedef struct {
	XCHAOS_DEF	def;		/* # */
	CHAOS_1		chaos_1;	/* (#) (id, menue, name, version, text, xor_lines,
										limits, (x_mem)) */
	CHAOS_2		chaos_2;	/* (#) (icon, xicon, typ, last_flag) */

	PAR_OFFS	offsets;	/* wird von xchaos ausgefllt */
} XCHAOS;
