/*
 *  WIND_UPDATE                                 (C) Digital Design 1990
 *
 *  Der Befehl kann zwei verschiedene Funktionen ausfhren:
 *  1. AES wird meitgeteilt, da die Applikation einen Bildschirmbereich
 *     neu aufbaut bzw. da der Neuaufbau beendet ist. Whrend dieser
 *     Zeit lt GEM keine Benutzeraktivitten zu.
 *  2. AES wird mitgeteilt, da die Applikation die berwachung
 *     smtlicher Mausfunktionen bernimmt bzw. GEM wieder bergibt.
 *     Im ersten Fall meldet AES der Applikation nicht mehr, wenn der
 *     Benutzer Position und Gre eines Fensters ndern will. Auerdem
 *     sind die Drop-Down-Mens inaktiv.
 */
#include <gemdefs.h>

int wind_update( int wi_ubegend )
{
  intin[0] = wi_ubegend; /* Art der Funktion:                           *
                          *  0 = Ende des Bildaufbaus (END_UPDATE)      *
                          *  1 = Beginn des Bildaufbaus (BEG_UPDATE)    *
                          *  2 = Ende der Mauskontrolle durch den       *
                          *      Benutzer (END_MCTRL)                   *
                          *  3 = Beginn der Mauskontrolle durch den     *
                          *      Benutzer (BEG_MCTRL)                   */
  AES( 107, 1, 1, 0, 0 );

  return intout[0]; /* = wi_ureturn: positiv bei Erfolg, 0 bei Fehler   */
}

