#ifndef _TYPES_H
#define _TYPES_H

#ifndef _COMPILER_H
#include <compiler.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _SIZE_T
#define _SIZE_T __SIZE_TYPEDEF__
typedef _SIZE_T size_t;
#endif

#ifndef _TIME_T
#define _TIME_T long
typedef _TIME_T time_t;
#endif

typedef long off_t;

typedef unsigned char	u_char;
typedef unsigned short	u_short;
typedef unsigned long	u_long;

typedef unsigned short	dev_t;		/* holds a device type */
#define major(dev)	(((dev)&0xff00)>>8)
#define minor(dev)	((dev)&0x00ff)

typedef u_long		ino_t;		/* holds an inode (fake under GEMDOS) */
typedef _UID_T		uid_t;		/* user id type */
typedef _GID_T		gid_t;		/* group id type */
typedef _PID_T		pid_t;		/* process id type */
typedef void *		caddr_t;

struct utimbuf {			/* type for times() call */
	time_t	actime;
	time_t	modtime;
};

#ifdef __cplusplus
}
#endif

#endif /* _TYPES_H */
