/*
 *  VEX_MOTV					(C) Digital Design 1990
 *
 *  EXCHANGE MOUSE MOVEMENT VECTOR
 *
 *  Mit Hilfe dieser Funktion knnen die Aktionen der Maus umfangreicher
 *  verwaltet werden. Der Routine wird eine Adresse bergeben, zu der
 *  VDI bei Bewegung der Maus springen soll. Vor Verzweigung zu dieser
 *  Mausroutine wird die neue x/y-Position des Cursors berechnet, jedoch
 *  noch nicht aktualisiert.
 *  Die Funktion gibt die Adresse der bisherigen Mausroutine zurck.
 *  Das Setzen und Zurcksetzen der Register mu vom Programm selbst
 *  sichergestellt sein.
 *  Die neue x/y-Position des - noch unsichtbaren - Cursors kann aus
 *  Prozessorregistern ausgelesen, aber auch gendert werden. Erst nach
 *  Rcksprung zum VDI..\VDI.HLP wird diese Position als aktuelle Position
 *  gespeichert.
 */
#include <gemdefs.h>

void vex_motv( int handle, int (*pusrcode)(), int (**psavcode)() )
{
  *(int (**)())(contrl + 7) = pusrcode; 	/* Adresse der neuen	*
						 * Mausbewegungsroutine */
  VDI( 126, 0, 0, handle );

  *psavcode = *(int (**)())(contrl + 9);	/* Adresse der alten	*
						 * Mausbewegungsroutine */
}