/*
 *  V_ELLARC					(C) Digital Design 1991
 *
 *  Mit dieser Funktion kann der Ausschnitt einer Ellipse gezeichnet
 *  werden, der sich durch Angabe von Mittelpunkt, X- und Y-Radius,
 *  Anfangs- und Endwinkel ergibt.
 *  Folgende Attribut fr Linien finden dabei Verwendung:
 *	Linienfarbe
 *	Linientyp
 *	Zeichenmodus
 *	Linienbreite
 *	Endform
 */
#include <gemdefs.h>

void v_ellarc( int handle, int x, int y, int xradius, int yradius,
	       int begang, int endang )
{
  intin[0] = begang; /* Startwinkel (0-3600)			*/
  intin[1] = endang; /* Endwinkel (0-3600)			*/
  ptsin[0] = x; /* x-Koordinate des Mittelpunktes		*/
  ptsin[1] = y; /* y-Koordinate des Mittelpunktes		*/
  ptsin[2] = xradius; /* Radius in x-Richtung			*/
  ptsin[3] = yradius; /* Radius in y-Richtung			*/

  contrl[5] = 6; VDI( 11, 2, 2, handle );
}
